;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


nolist


DIRECCION_INICIO_JUEGO equ #90
TAM_BINARIO_JUEGO      equ 33264


print "TAM_BINARIO_JUEGO   &TAM_BINARIO_JUEGO"


POSICION_CARGADOR equ #8300

org POSICION_CARGADOR
run inicio
jp inicio


read "../src/libs/macros_comparaciones.asm"
read "../src/libs/colores.asm"
read "../src/libs/video.asm"
read "../src/libs/teclado.asm"
read "../src/libs/zx0/dzx0_standard.asm"
read "miniload.asm"



.paleta:
	db sw_0
	db sw_1 , sw_2 , sw_3 , sw_4 , sw_15 
	db sw_9 , sw_11 , sw_13 , sw_15 , sw_16 
	db sw_18 , sw_20 , sw_21 , sw_24 , sw_26 



inicio:

DI

ld c, 16 
ld a, sw_0
call set_ink

call set_int_handler_nulo
call set_modo_pantalla
call set_paleta_negro
call set_color_logo

ld hl, pantalla
ld de, #c000
call dzx0_standard

ld ix, pantalla
ld de, 7767
call cpct_miniload_asm

ld hl, pantalla
ld de, #c000
call dzx0_standard

call set_paleta_pantalla


ld ix, DIRECCION_INICIO_JUEGO
ld de, TAM_BINARIO_JUEGO  
call cpct_miniload_asm

call set_color_logo

ei

key_loop:
	call scan_keyboard
	call is_any_key_pressed
	jr z, key_loop

call set_paleta_negro

jp DIRECCION_INICIO_JUEGO



set_paleta_pantalla:
	ld hl, paleta
	call set_palette
	ret


set_paleta_negro:
	ld a, sw_0
	call set_paleta_igual
	ret


set_color_logo:
	ld c, 5
	ld a, sw_15 
	call set_ink
	ret


set_modo_pantalla
	ld a, 0
	call set_video_mode
	ret


set_int_handler_nulo:
	ld a, #fb ; ei
	ld (#0038), a
	ld bc, #4ded;  reti 
	ld (#0039), bc
	ret


pantalla:
incbin "solo_logo.bin.zx0"

FIN:

let addr_fin=$
print "INICIO    $POSICION_CARGADOR"
print "FIN       $addr_fin"

db 0,#7f


