;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

if ANIMACION_PAJAROS=1
;((((((((((((((((((((((((((((((((((((((()))))))))))))))))))))))))))))))))))))))

DIR_SPRITES_PAJAROS  equ #8000
SPRITES_PAJAROS_1 equ DIR_SPRITES_PAJAROS
SPRITES_PAJAROS_2 equ SPRITES_PAJAROS_1+80
SPRITE_VACIO      equ SPRITES_PAJAROS_2+168
PAJARO_DELAY equ 10


macro new_AnimacionPajaro _ini_x, _ini_y, _n_frms, _incr_x, _incr_y, _frm0, _tamspr, _dimaa, _inc_frm, _frm1
	BeginStruct T_ANI_PAJARO
		DeclareFieldStruct T_ANI_PAJARO, INI_X, 1 
		db _ini_x
		DeclareFieldStruct T_ANI_PAJARO, INI_Y, 1 
		db _ini_y
		DeclareFieldStruct T_ANI_PAJARO, MAX_FRAMES, 1
		db _n_frms
		DeclareFieldStruct T_ANI_PAJARO, INCR_X, 1
		db _incr_x
		DeclareFieldStruct T_ANI_PAJARO, INCR_Y, 1
		db _incr_y
		DeclareFieldStruct T_ANI_PAJARO, FRAME0, 2
		dw _frm0
		DeclareFieldStruct T_ANI_PAJARO, TAM_SPRITE, 1
		db _tamspr
		DeclareFieldStruct T_ANI_PAJARO, DIMAA, 1
		db _dimaa
		DeclareFieldStruct T_ANI_PAJARO, 800AA, 2
		dw #800-_dimaa
		DeclareFieldStruct T_ANI_PAJARO, INC_FRAME, 1
		db _inc_frm
		DeclareFieldStruct T_ANI_PAJARO, FRAME, 1 
		db _frm1
	EndStruct T_ANI_PAJARO
endm


animaciones_pajaro:
	new_AnimacionPajaro  0,  100,  50, 2, 1, SPRITES_PAJAROS_1, 20, 4, 1, 0
	new_AnimacionPajaro 50,  125,  50,-2,-1, SPRITES_PAJAROS_1, 20, 4,-1, 3
	
	new_AnimacionPajaro 90,  122,  46, 2,-1, SPRITES_PAJAROS_1, 20, 4, 1, 0
	new_AnimacionPajaro 136, 100,  44,-2, 1, SPRITES_PAJAROS_1, 20, 4,-1, 3

	new_AnimacionPajaro  0,   92,  44, 2, 1, SPRITES_PAJAROS_2, 42, 6, 1, 0
	new_AnimacionPajaro 44,  123,  44,-2,-1, SPRITES_PAJAROS_2, 42, 6,-1, 3
	
	new_AnimacionPajaro 82,  111,  50, 2,-1, SPRITES_PAJAROS_2, 42, 6, 1, 0
	new_AnimacionPajaro 132,  90,  44,-2, 1, SPRITES_PAJAROS_2, 42, 6,-1, 3

	

animacion_pajaro:
	ds TAM_T_ANI_PAJARO
	
animacion_pajaro_cont_frames:
	db 0	
	
animacion_pajaro_hay:
	db 0

animacion_delay:
	db PAJARO_DELAY
	
animacion_no_crear:
	db 5
	

animacion_pajaro_animar:
	ld a, (animacion_pajaro_hay)
	or a
	jr nz, _apa2
		ld hl, animacion_no_crear
		ld a, (hl)
		or a
		jr z, _apa3
			dec (hl)
			ret
_apa3
		call anima_pajaro_crear
		ret
_apa2
	ld hl, animacion_delay
	dec (hl)
	ret nz
	
	ld (hl), PAJARO_DELAY

	ld ix, animacion_pajaro
	ld a, (animacion_pajaro_cont_frames)
	cp (ix + T_ANI_PAJARO_MAX_FRAMES)
	jr nz, _apa0
		xor a
		ld (animacion_pajaro_hay), a
		ld a, 255
		ld (animacion_no_crear), a
		
		call anima_pajaro_calc_destino 
		ex de, hl
		ld hl, SPRITE_VACIO
		jr _apa1
_apa0
	call anima_pajaro_calc_sprite 
	
	push hl
		call anima_pajaro_calc_destino 
	pop de 
	
	ex de, hl  
_apa1
	ld bc, (__spr_r_ancho)
	push bc
	ld bc, (__spr_r_800_ancho)
	push bc
		;pintar sprite
		ldw_ri bc, ix, T_ANI_PAJARO_800AA
		ld (__spr_r_800_ancho), bc

		ld b, 0
		ld c, (ix + T_ANI_PAJARO_DIMAA)
		ld (__spr_r_ancho), bc
		
		inc c
		ld iyh, c

		call sprite_render
	pop bc
	ld (__spr_r_800_ancho), bc
	pop bc
	ld (__spr_r_ancho), bc
	
	ld hl, animacion_pajaro_cont_frames
	inc (hl)
	bit 0, (hl)
	jr nz, _apa4
		ld a, (ix + T_ANI_PAJARO_INI_X)
		add (ix + T_ANI_PAJARO_INCR_X)
		ld (ix + T_ANI_PAJARO_INI_X), a

		ld a, (ix + T_ANI_PAJARO_INI_Y)
		add (ix + T_ANI_PAJARO_INCR_Y)
		ld (ix + T_ANI_PAJARO_INI_Y), a	
_apa4
	ld a, (ix + T_ANI_PAJARO_FRAME)
	add (ix + T_ANI_PAJARO_INC_FRAME)
	ld (ix + T_ANI_PAJARO_FRAME), a
	RET



anima_pajaro_crear:
	ld a, (random_partida)
	cp 7
	ret_si_A_mayor_o_igual
	
	and %00000111
	ld hl, TAM_T_ANI_PAJARO
	call multiplicar
	ld bc, animaciones_pajaro
	add hl, bc	

	ld de, animacion_pajaro
	ld bc, TAM_T_ANI_PAJARO
	ldir
	
	xor a
	ld hl, animacion_pajaro_cont_frames
	ld (hl), a

	inc hl 
	inc a 
	ld (hl), a
	
	inc hl
	ld (hl), 1	
	
	ret
	


anima_pajaro_calc_destino:
	ld b, (ix + T_ANI_PAJARO_INI_Y)
	ld c, (ix + T_ANI_PAJARO_INI_X)
_ap_calc_destino
	call coordenada_calcular_desplazamiento 
	ld bc, #c000
	add hl, bc
	ret



anima_pajaro_calc_sprite:
	ld h, 0
	ld l, (ix + T_ANI_PAJARO_TAM_SPRITE)
	ld a, (ix + T_ANI_PAJARO_frame)
	and %00000011
	call multiplicar
	ldw_ri bc, ix, T_ANI_PAJARO_FRAME0
	add hl, bc
	ret
	
	
	

descomprimier_sprites_pajaros:
	ld hl, sprites_pajaros_zx0
	ld de, DIR_SPRITES_PAJAROS
	call dzx0
	ret



sprites_pajaros_zx0:
	incbin "incluir\pajaros.bin.zx0"


;((((((((((((((((((((((((((((((((((((((()))))))))))))))))))))))))))))))))))))))
endif