;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


MODO_CANIBAL_BUSCA equ 1
MODO_CANIBAL_TONTO equ 0



MAX_MOVER_CANIBAL equ 2

.cont_mover_canibal:
	db #00

.hay_canibal:
	db 0

.modo_canibal
	db 0


check_hay_canibal:
	ld a, (hay_canibal)
	cp 1
	ret


anadir_canibal:
	ld a, (hay_objeto)
	cp 1
	ret z

	ld a, (pantalla_ambiente)
	cp AMB_CUEVA  
	ret z

	ld a, (pantalla_mapa_yx)
	listabytes_find array_pantallas_sin_canibal, TAM_ARRAY_PANTALLAS_SIN_CANIBAL
	ret z 

_ac_random
	ld a, (random_enemigo)
	cp PORCENTAJE_APARICION_CANIBAL
	ret_si_A_mayor_o_igual

_ac_anadir
	ld ix, animacion_enemigo
	ld (ix + ANIMACION_PASOS), 0

	call canibal_set
	call canibal_reset_ia

	ld a, (direccion_jugador)
	ld b, a
	call pantalla_get_random_celda_pisable_canibal 

	ld a, l
	ld (enemigo_celda_num), a
	ld b, PANTALLA_ANCHO
	call format44_get_y_x
	ld b, c
	ld c, a
	ld (enemigo_celda), bc

	ld a, (direccion_jugador)
	call get_direccion_opuesta 


canibal_cargar_sprites:
	call get_sprites_canibal

	ld a, MAX_MOVER_CANIBAL
	ld (cont_mover_canibal), a

	ret

get_direccion_opuesta:
	ld hl, direcciones_opuestas
	ld b, 0
	ld c, a
	add hl, bc
	ld a, (hl)
	RET



canibal_set:
	ld a, 1
	jr canibal_rs_prv
	

canibal_reset:
	ld a, #ff
	ld (sprites_descomprimidos_canibal), a
	xor a
	
	
canibal_rs_prv:
	ld (hay_canibal), a
	ld (modo_canibal), a
	RET



canibal_mover:
	ld a, #ff
	ld b, MAX_MOVIMIENTOS_ENEMIGO
	ld hl, alg_lista_movimientos_enemigo-1
_cb_loop
	inc hl
	cp (hl)
	jr nz, canibal_mover_procesar_movimiento
	djnz _cb_loop

	call buscar_ruta_enemigo
	ld a, (alg_num_celdas_pisadas)
	or a 
	ret z
	ld hl, alg_lista_movimientos_enemigo



canibal_mover_procesar_movimiento:
	ld a, (sprites_descomprimidos)
	or a
	ret nz 

	ld a, (hl)
	ld (hl), #ff
	ld (direccion_enemigo), a
	ld ixh, a 

	push hl
		call get_sprites_canibal
	pop hl

	if MAX_MOVIMIENTOS_ENEMIGO=2
		dec hl 
		dec hl 
	elseif MAX_MOVIMIENTOS_ENEMIGO=3
		dec hl 
		dec hl 
		dec hl 
	else
		ld bc, MAX_MOVIMIENTOS_ENEMIGO
		add hl, bc
	endif
	ld a, (hl) 
	ld (enemigo_celda_num), a
	ld d, a 

	ld hl, incrementos_movimientos
	ld b, 0
	ld c, ixh
	sla c
	add hl, bc
	ldw_indi bc 
	ldw_rr hl, bc
	ld bc, (enemigo_celda)
	add hl, bc 
	ld (enemigo_celda), hl

	ld_a 1
	ld (personaje_avanzar_quien), a
	ld b, ixh
	ld a, d
	ld de, coordenadas_enemigo
	ld hl, celdas_afectadas_enemigo
	ld iy, animacion_enemigo
	call personaje_avanzar

	ret


check_mover_canibal:
	ld hl, cont_mover_canibal
	dec (hl)
	ret nz

	ld (hl), MAX_MOVER_CANIBAL
	xor a
	ret


get_modo_canibal:
	ld a, (hay_canibal)
	cp 1
	ret nz
	ld a, (modo_canibal)
	cp 1
	ret



turno_canibal:
	call get_modo_canibal
	jr z, _tc_modo_busca
		push iy
			ld iy, animacion_enemigo
			dec (iy + ANIMACION_SUBNFRAME)
			jr nz, _tc_no_cambiar
				ld (iy + ANIMACION_SUBNFRAME), MAX_SUB_NFRAMES+MAX_SUB_NFRAMES+MAX_SUB_NFRAMES
				dec (iy + ANIMACION_NFRAME)
_tc_no_cambiar
		pop iy
		ret
_tc_modo_busca
	ld a, (animacion_enemigo + ANIMACION_PASOS)
	or a ;cp 0
	jr z, _tc_mover_canibal
		call check_mover_canibal 
		ret z
			AnimarCanibal
			ret
_tc_mover_canibal
	call canibal_mover
	ret

