;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------



MAX_MOVIMIENTOS_ENEMIGO equ 3

DIR_UP equ 0
DIR_DO equ 1
DIR_LE equ 2
DIR_RI equ 3

MOV_UP equ #ff00
MOV_DO equ #0100
MOV_LE equ #ffff
MOV_RI equ #0001



.direcciones_opuestas:
	db 1, 0, 3, 2


.incrementos_movimientos:
	dw MOV_UP, MOV_DO, MOV_LE, MOV_RI

.direfencia_celdas:
	db -PANTALLA_ANCHO, PANTALLA_ANCHO, -1, 1


macro DireccionOpuesta _dir
	if "_dir"="DIR_UP"
		db DIR_DO
	elseif "_dir"="DIR_DO"
		db DIR_UP
	elseif "_dir"="DIR_LE"
		db DIR_RI
	elseif "_dir"="DIR_RI"
		db DIR_LE
	endif
endm


macro new_PrioridadMovimientos _clave, _dir1, _dir2
	db _clave, _dir1, _dir2
	DireccionOpuesta _dir2
	DireccionOpuesta _dir1
endm


prioridades_movimientos:
	new_PrioridadMovimientos %10000011, DIR_RI, DIR_DO
	new_PrioridadMovimientos %10000010, DIR_RI, DIR_UP
	new_PrioridadMovimientos %10000001, DIR_LE, DIR_DO
	new_PrioridadMovimientos %10000000, DIR_LE, DIR_UP
	new_PrioridadMovimientos %01000011, DIR_DO, DIR_RI
	new_PrioridadMovimientos %01000001, DIR_DO, DIR_LE
	new_PrioridadMovimientos %01000010, DIR_UP, DIR_RI
	new_PrioridadMovimientos %01000000, DIR_UP, DIR_LE




.alg_enemigo:
.alg_enemigo_x:
	db #00
.alg_enemigo_y:
	db #00
.alg_enemigo_num_celda:
	db #00

.alg_num_celdas_pisadas:
	db 0

.alg_lista_celdas_pisadas:
	ds MAX_MOVIMIENTOS_ENEMIGO+1

.alg_lista_movimientos_enemigo:
	ds MAX_MOVIMIENTOS_ENEMIGO



canibal_reset_ia:
	listabytes_reset alg_lista_celdas_pisadas+1, MAX_MOVIMIENTOS_ENEMIGO+MAX_MOVIMIENTOS_ENEMIGO, #ff
	xor a
	ld (alg_num_celdas_pisadas), a
	ret



buscar_ruta_enemigo:
	call canibal_reset_ia

	ld a, (enemigo_celda_num)
	ld (alg_lista_celdas_pisadas), a
	ld (alg_enemigo_num_celda), a

	ld bc, (enemigo_celda)
	ld (alg_enemigo), bc

	jr _bre_ini

_bre_loop_grande
	ld a, (alg_num_celdas_pisadas)
	cp MAX_MOVIMIENTOS_ENEMIGO
	ret z
_bre_ini
	ld de, (jugador_celda)
	ld bc, (alg_enemigo)  
	ld a, d
	cp b
	jr nz, _bre_sigue
	ld a, e
	cp c
	ret z

_bre_sigue
	ld a, b
	sub d
	ld h, a

	ld a, c
	sub e
	ld l, a

	xor a
	bit 7, h
	jr_si_bit_igual_0  _bre_creando_clave1 
		or %00000001 
_bre_creando_clave1
	bit 7, l
	jr_si_bit_igual_0  _bre_creando_clave2 
		or %00000010 
_bre_creando_clave2
	ld iyh, a 

	ld a, h
	call absA
	ld h, a   

	ld a, l
	call absA
	ld l, a   

	ld a, h
	sub l
	ld a, iyh 
	jr nc, _bre_dy_mayor
	or %10000000
	jr _bre_comprobar_direcciones
_bre_dy_mayor
	or %01000000
_bre_comprobar_direcciones
	ArraySearch prioridades_movimientos, 8, 5

	ld iyl, 4 
_bre_loop
	inc hl 
	push hl
		ld a, (hl)
		call evaluar_movimiento_enemigo 
	pop hl
	jr nz, almacenar_movimiento_enemigo
	dec iyl
	jr nz, _bre_loop

	RET


almacenar_movimiento_enemigo:
	ld (alg_enemigo_num_celda), a
	ld e, a 

	ld (alg_enemigo), bc
	ld a, c
	ld (alg_enemigo_x), a
	ld a, b
	ld (alg_enemigo_y), a

	ld hl, alg_num_celdas_pisadas
	ld b, 0
	ld c, (hl)
	inc (hl)

	ld hl, alg_lista_movimientos_enemigo
	add hl, bc
	ld (hl), d

	ld hl, alg_lista_celdas_pisadas+1
	add hl, bc
	ld (hl), e 

	jp _bre_loop_grande



evaluar_movimiento_enemigo:
	ld (__eve_direccion1), a
	ld (__eve_direccion2), a

	ld hl, incrementos_movimientos
	ld b, 0
	ld c, a
	sla c 
	add hl, bc 

	ld c, (hl)
	inc hl
	ld b, (hl) 

	ld hl, (alg_enemigo)
	add hl, bc 

	ld a, -1 
	cp h
	ret z
	cp l
	ret z

	ld a, PANTALLA_ALTO
	cp h     
	ret z
	ld a, PANTALLA_ANCHO
	cp l     
	ret z

	ld b, h  
	ld c, l  

	ld de, #0000
	__eve_direccion1 equ $-2 
	ld hl, direfencia_celdas
	add hl, de 
	ld a, (alg_enemigo_num_celda)
	add a, (hl)

	ld h, PANTALLA_BYTEH
	ld l, a
	
	ld a, (hl)
	or a 
	jr z, _mov_vale
	
_cia_hack
	db #00 
	jr c,  _cia_playa
_cia_bosque
	cp CELDA_TABLA
	jr z, _mov_vale
	cp CELDA_PISABLE_HIERBA_ARENA
	jr z, _mov_vale
	jr _mov_novale
_cia_playa
	cp CELDA_PISABLE_ARENA
	jr z, _mov_vale
	cp CELDA_PISABLE_ARENA_HIERBA
	jr z, _mov_vale
	cp CELDA_PISABLE_ARENA_AGUA
	jr z, _mov_vale
	
_mov_novale
	xor a 
	ret

_mov_vale
	or 1 
	ld a, l
	ld d, #00 
	__eve_direccion2 equ $-1
	ret



canibalia_set_ambiente:
	ld hl, _cia_hack
	ld a, (pantalla_ambiente)
	ld bc, #0100
	cp b
	jr z, _cia_set_bosque
	cp c
	jr z, _cia_set_playa
_cia_set_bosque
	ld (hl), #00  
	ret
_cia_set_playa
	ld (hl), #37  
	ret
