;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


ID_CELDA_AGUA_MAR_1 equ 1
ID_CELDA_AGUA_MAR_2 equ 99
XOR_CELDAS       equ %01100010
CELDA_PIEDRA_AGUA  equ 11
CELDA_PIEDRA_ARENA equ 5 


celda_mar_reset:
	ld a, 1
	ld (celda_mar_cambiar), a
	RET


celda_mar_cambiar:
	db 0

celda_mar_num:
	db 0
	
celda_mar_valor:
	db 0


animacion_mar:
	ld a, (pantalla_ambiente)
	or a
	ret nz
	
	ld hl, celda_mar_cambiar
	inc (hl)
	bit 0, (hl)
	jr z, _am_calc_celda

		ld de, (celda_mar_num)
		jr _am_pintar1	
	
_am_calc_celda
	ld e, PANTALLA_TAM
	call random_max_e
	ld h, PANTALLA_BYTEH
	ld l, a
	ld e, a
	
	ld a, (hl)
	ld d, a   
	cp ID_CELDA_AGUA_MAR_1 
	jr z, _am_mirar_celda_abajo
	cp ID_CELDA_AGUA_MAR_2 
	jr z, _am_mirar_celda_abajo
		jr am_pasar_turno

_am_mirar_celda_abajo
	ld a, l
	cp PANTALLA_TAM-PANTALLA_ANCHO
	jr_si_A_mayor _am_cambiar 
	add PANTALLA_ANCHO
	ld l, a
	ld a, (hl)
	ld bc, #050b
	cp b
	jr z, am_pasar_turno
	cp c
	jr z, am_pasar_turno
	ld a, d
	
_am_cambiar
	ld a, d
	xor XOR_CELDAS
	ld l, e
	ld (hl), a
	ld d, a
	ld (celda_mar_num), de
	
_am_pintar1
	ld a, d
	cp ID_CELDA_AGUA_MAR_1
	jr z, _am_mar_quieto
	cp ID_CELDA_AGUA_MAR_2
	jr z, _am_mar_movimiento
	ret
_am_mar_quieto
	ld ix, tipos_celdas+TAM_CELDA 
	jr _am_pintar2
_am_mar_movimiento
	ld ix, celda_agua_mar_2

_am_pintar2
	ld hl, array_offsets_tiles
	sla e
	ld d, 0 
	add hl, de
	ldw_indi de
	ex de, hl
	add_backbuffer_to h

	call render_celda_parte_abajo 
	RET


am_pasar_turno:
		ld hl, celda_mar_cambiar
		ld (hl), 1
		ret

