;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

CELDA_NULA equ #FF

MAX_CELDAS_AFECTADAS equ 8
LADO_DETRAS  equ #d1
LADO_DELANTE equ #d2



macro new_CeldaAfectada
let fill_byte=CELDA_NULA
	BeginStruct CELDA_AFECTADA
		FieldStruct CELDA_AFECTADA, LADO, 1           
		FieldStruct CELDA_AFECTADA, CELDA, 2 
		FieldStruct CELDA_AFECTADA, OFFSET, 2   
		FieldStruct CELDA_AFECTADA, FUNC_REPINTAR, 2  
		FieldStruct CELDA_AFECTADA, NUM_CELDA, 1
	EndStruct CELDA_AFECTADA
let fill_byte=#00
endm



macro new_CELDAS_AFECTADAS
	repeat MAX_CELDAS_AFECTADAS
		new_CeldaAfectada
	rend
endm


macro new_DefinicionCeldaAfectada _lado, _celda_relativa, _func_repintar
    BeginStruct DEF_CA
        db _lado
        db _celda_relativa
        dw _func_repintar
        DeclareFieldStruct DEF_CA, LADO, 1
        DeclareFieldStruct DEF_CA, CELDA_RELATIVA, 1
        DeclareFieldStruct DEF_CA, FUNC_REPINTAR, 2
    EndStruct DEF_CA
endm





.definicion_ca_mov_horizontal:
    new_DefinicionCeldaAfectada LADO_DETRAS, -PANTALLA_ANCHO, render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DETRAS, -PANTALLA_ANCHO+1, render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DETRAS, 0, render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DETRAS, 1, render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO, render_celda_parte_arriba
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+1, render_celda_parte_arriba
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO, render_celda_parte_arriba_top
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO+1, render_celda_parte_arriba_top

TAM_DEF_CA_HORIZONTAL equ 8


.definicion_ca_mov_vertical:
    new_DefinicionCeldaAfectada LADO_DETRAS, -PANTALLA_ANCHO-PANTALLA_ANCHO, render_celda_parte_abajo
.definicion_ca_vertical_simple:
    new_DefinicionCeldaAfectada LADO_DETRAS, -PANTALLA_ANCHO, render_celda_parte_abajo
.definicion_ca_vertical_objeto:
    new_DefinicionCeldaAfectada LADO_DETRAS, 0, render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO, render_celda_parte_arriba
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO, render_celda_parte_arriba_top

.definicion_ca_vertical_serpiente_caso1:
    new_DefinicionCeldaAfectada LADO_DETRAS, -PANTALLA_ANCHO,                render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DETRAS,  0,                             render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO,                render_celda_parte_arriba
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO,                render_celda_parte_arriba_top
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO, render_celda_parte_arriba_top

.definicion_ca_vertical_serpiente_caso2:
    new_DefinicionCeldaAfectada LADO_DETRAS, -PANTALLA_ANCHO,                render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DETRAS,  0,                             render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DETRAS,  PANTALLA_ANCHO,                render_celda_parte_abajo
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO, render_celda_parte_arriba
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO, render_celda_parte_arriba_top
    new_DefinicionCeldaAfectada LADO_DELANTE, PANTALLA_ANCHO+PANTALLA_ANCHO+PANTALLA_ANCHO, render_celda_parte_arriba_top
	

TAM_DEF_CA_VERTICAL equ 5


TAM_DEF_CA_VERTICAL_SERPIENTE_CASO1 equ 5 
TAM_DEF_CA_VERTICAL_SERPIENTE_CASO2 equ 6 

TAM_DEF_CA_VERTICAL_SIMPLE equ 4
TAM_DEF_CA_VERTICAL_OBJETO equ 3





celdas_afectadas_reset:
    ld a, CELDA_NULA
    ld de, TAM_CELDA_AFECTADA
    ld b, MAX_CELDAS_AFECTADAS
    call array_reset
    ret



macro ResetCeldasAfectadas _arr_celdas_afectadas
	ld hl, _arr_celdas_afectadas
	call celdas_afectadas_reset
endm




ca_calcular_vertical_serpiente:
    ld (__ca_celda_ref), a
	
	ld d, a 
	add PANTALLA_ANCHO
	
	ld l, a
	ld h, PANTALLA_BYTEH
	ld a, (hl) 
	
	call get_tile 
	bit CELDA_BIT_PISABLE, (ix + CELDA_FLAGS)
	jr z, _ca_cvs_nopisable
_ca_cvs_pisable
    ld a, TAM_DEF_CA_VERTICAL_SERPIENTE_CASO2
	ld ix, definicion_ca_vertical_serpiente_caso2
    jr ca_calcular_comun
_ca_cvs_nopisable
    ld a, TAM_DEF_CA_VERTICAL_SERPIENTE_CASO1
    ld ix, definicion_ca_vertical_serpiente_caso1
    jr ca_calcular_comun
	
	
	



ca_calcular_vertical_objeto:
    ld (__ca_celda_ref), a
    ld a, TAM_DEF_CA_VERTICAL_OBJETO
    ld ix, definicion_ca_vertical_objeto
    jr ca_calcular_comun


ca_calcular_vertical_simple:
    ld (__ca_celda_ref), a
    ld a, TAM_DEF_CA_VERTICAL_SIMPLE
    ld ix, definicion_ca_vertical_simple
    jr ca_calcular_comun


ca_calcular_vertical:
    ld (__ca_celda_ref), a
    ld a, TAM_DEF_CA_VERTICAL
    ld ix, definicion_ca_mov_vertical
    jr ca_calcular_comun


ca_calcular_horizontal:
    ld (__ca_celda_ref), a
    ld a, TAM_DEF_CA_HORIZONTAL
    ld ix, definicion_ca_mov_horizontal


ca_calcular_comun:
    exx
        ld h, a 
        ld bc, TAM_CELDA_AFECTADA
        ld de, TAM_DEF_CA
    exx

_ca_ch_loop
    ld a, #00 
    __ca_celda_ref equ $-1
    add a, (ix + DEF_CA_CELDA_RELATIVA) 
	ld (iy + CELDA_AFECTADA_NUM_CELDA), a

	bit 7, a
	jr nz, _ca_ch_neg
    
    cp PANTALLA_TAM 
    jr nc, _ca_ch_sig

    ld (__ca_num_celda), a
    ld l, a              
    ld h, PANTALLA_BYTEH
    ld a, (hl)  

    push ix
        call get_tile 
        ldw_rr bc, ix
	    ldw_ir iy, CELDA_AFECTADA_CELDA, bc
    pop ix

    ldw_ri bc, ix, DEF_CA_FUNC_REPINTAR
    ldw_ir iy, CELDA_AFECTADA_FUNC_REPINTAR, bc

    ld hl, array_offsets_tiles
    ld a, #00
    __ca_num_celda equ $-1
    call get_word_array   
    ldw_indi de 
	ldw_ir iy, CELDA_AFECTADA_OFFSET, de

    ld a, (ix + DEF_CA_LADO)
    ld (iy + CELDA_AFECTADA_LADO), a
_ca_ch_sig
    exx
        dec h
        jr z, _ca_ch_fin
        add ix, de
        add iy, bc
    exx
    jr _ca_ch_loop
_ca_ch_fin
    exx
    ret
_ca_ch_neg
	add PANTALLA_ANCHO
	bit 7, a
	jr nz, _ca_ch_sig 
_ca_fila_menos_1
	ld hl, array_offsets_tiles
	call get_word_array 
	ldw_indi de 
	ld hl, -SCREEN_WIDTH-SCREEN_WIDTH 
	add hl, de
    ldw_ir iy, CELDA_AFECTADA_OFFSET, hl

	ld a, LADO_DETRAS
    ld (iy + CELDA_AFECTADA_LADO), a
	ld bc, render_celda_parte_abajo_negro
	ldw_ir iy, CELDA_AFECTADA_FUNC_REPINTAR, bc

	jr _ca_ch_sig





celdas_afectadas_render_celdas:
	ld c, MAX_CELDAS_AFECTADAS
_ca_render_loop
	push bc
		ld a, b
		cp (iy + CELDA_AFECTADA_LADO)
		jr nz, _ca_render_siguiente    

		ldw_ri bc, iy, CELDA_AFECTADA_FUNC_REPINTAR
		ld (__func_render_celda), bc

		
		ldw_ri bc, iy, CELDA_AFECTADA_CELDA
		ldw_rr ix, bc
		ldw_ri hl, iy, CELDA_AFECTADA_OFFSET
		add_backbuffer_to h

		call #0000
		__func_render_celda equ $-2
_ca_render_siguiente
	pop bc
	dec c
	ret z

	ld de, TAM_CELDA_AFECTADA
	add iy, de
	jp _ca_render_loop




celdas_afectadas_anular_2_primeras:
	ld a, #ff
	ld bc, TAM_CELDA_AFECTADA
	ld (hl), a
	add hl, bc
	ld (hl), a
	RET



macro RenderCeldasAfectadasDetras _array_celdas_afectadas
	ld iy, _array_celdas_afectadas
	ld b, LADO_DETRAS
	call celdas_afectadas_render_celdas
endm



macro RenderCeldasAfectadasDelante _array_celdas_afectadas
	ld iy, _array_celdas_afectadas
	ld b, LADO_DELANTE
	call celdas_afectadas_render_celdas
endm





celdas_afectadas_cambiar_celda:
	ld b, MAX_CELDAS_AFECTADAS
	ld de, TAM_CELDA_AFECTADA
_ca_camb_loop
	cp (iy + CELDA_AFECTADA_NUM_CELDA)
	jr z, _ca_camb_esta	
	add iy, de
	djnz _ca_camb_loop
	ret
_ca_camb_esta
	ld (iy + CELDA_AFECTADA_NUM_CELDA), a
	ld a, c
	call get_tile ; >a <ix
	ldw_rr bc, ix
    ldw_ir iy, CELDA_AFECTADA_CELDA, bc
	RET