;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

get_pantalla:
	call get_ambientes_pantalla
	call carga_sprites_celda_pantalla 
	call get_pantalla_celdas
if CELDAS_AZAR=1
	call pantalla_set_celdas_random
endif

 	call mapa_update_celdas_modificadas_pantalla
	
	ret


get_ambientes_pantalla:
	ld hl, array_ambientes_pantallas_zx0
	ld de, FIN
	call dzx0
	
	ld bc, (coordenadas_pantalla)
	ld e, MAPA_ANCHO_PANTALLAS
	call format44_get_secuencial ; <a
	ld hl, FIN
	ld b, 0
	ld c, a
	add hl, bc
	ld a, (hl)
	ret


get_pantalla_celdas:
	ld hl, array_posiciones_filas_mapa
	ld a, (pantalla_mapa_y)
	call get_word_array 
	ldw_indi bc 
	ldw_rr hl, bc

	ld de, PANT_INI+SCREEN_WIDTH+SCREEN_WIDTH+SCREEN_WIDTH
	add_backbuffer_to d

	push de 
		call dzx0
	pop hl 

	ld de, PANTALLA_TAM / 2
	ld a, (pantalla_mapa_x)
	call get_array_item 

	ld de, pantalla

	ld a, (sumador_conjunto_celdas_secundario)
	ld b, a  
	ld c, PANTALLA_TAM / 2
_gp_decodificar_bye
		ld a, (hl)
		and &f0
		rrca
		rrca
		rrca
		rrca
		bit 3, a
		jr z, _gp_byteH_celda_basica
			add b
_gp_byteH_celda_basica
		ld (de), a 
		inc e 
		ld a, (hl)
		and &0f
		bit 3, a
		jr z, _gp_byteL_celda_basica
			add b
_gp_byteL_celda_basica
		ld (de), a
		inc e  
		inc hl
	dec c
	jr nz, _gp_decodificar_bye
	RET



if CELDAS_AZAR=1
pantalla_set_celdas_random:
	ld a, (pantalla_ambiente)
	cp AMB_PLAYA
	ret z
	cp AMB_CABANA
	ret z
	
	call random_set_seed_pantalla
	
	ld d, #10
	ld b, PANTALLA_ANCHO*PANTALLA_ALTO
	ld l, b
	ld h, PANTALLA_BYTEH
_pscr_loop	
	dec l
	ld c, (hl)
	ld e, 3
	ld a, #1c
_pscr_loop_xC
	cp c
	jr z, _pscr_obstaculo
	add a, d 
	dec e
	jr nz, _pscr_loop_xC
	ld e, 3
	inc a  
	sub d  
_pscr_loop_xD
	cp c
	jr z, _pscr_sustituible
	sub d
	dec e
	jr nz, _pscr_loop_xD
	
	jr _pscr_siguiente
	
_pscr_obstaculo
		call random  
		and #03
		add 04 
		ld (hl), a
		jr _pscr_siguiente
		
_pscr_sustituible
		call random
		and #01
		add 2  
		ld (hl), a
		
_pscr_siguiente
	djnz _pscr_loop
	
	call random_restore_seed
	
	ret



semilla4:
	dw 0
semilla7:
	dw 0


random_set_seed_pantalla:
	ld bc, (random+7)
	ld (semilla7), bc
	ld bc, (random+4)
	ld (semilla4), bc
	
	ld bc, (pantalla_mapa_x) ; b=y c=x
	ld a, (random_partida)
	xor b
	ld b, a
	xor c
	ld c, a
	ld (random+4), bc
	xor %01100110
	xor b
	ld b, a
	xor c
	ld c, a
	ld (random+7), bc
	
	ret


random_restore_seed:
	ld bc, (semilla7)
	ld (random+7), bc
	ld bc, (semilla4)
	ld (random+4), bc
	ret
endif


carga_sprites_celda_pantalla:
_gdp_2
	ld ixh, a
	call format44_split_byte 
	ld a, d 
	ld hl, conjunto_celdas_primario 
	cp (hl) 
	jr z, _gdp_3
		ld (conjunto_celdas_primario), a
		call cargar_conjunto_celdas_primario_prv
_gdp_3
	ld a, ixh 
	and #0f
	cp #0f
	ret z
	ld hl, conjunto_celdas_secundario ;10
	cp (hl)
	ret z
		ld (conjunto_celdas_secundario), a
		ld b, a
		add a, a
		add a, a
		add a, a
		add a, a
		ld (sumador_conjunto_celdas_secundario), a
		call cargar_conjunto_celdas_secundario
	RET




cargar_conjunto_celdas_primario:
	ld a, (conjunto_celdas_primario)
cargar_conjunto_celdas_primario_prv
	ld hl, array_sprites1_zx0
	call get_word_array
	ldw_indi bc
	ldw_rr hl, bc
	ld de, sprites_celdas_primarias 
	call dzx0
	ret


cargar_conjunto_celdas_secundario:
	ld a, (conjunto_celdas_secundario)
	ld hl, array_sprites2_zx0
	call get_word_array
	ldw_indi bc
	ldw_rr hl, bc
	ld de, sprites_celdas_secundarias 
	call dzx0
	ret
	
mapa_update_celdas_modificadas_pantalla:
	ld h, PANTALLA_BYTEH
	ld iy, array_celdas_modificadas
	ld b, MAX_CELDAS_MODIFICADAS
_updm_loop
	ld a, (pantalla_mapa_yx)
	cp (iy + CELDA_MODIFICADA_PANTALLA)
	jr nz, _updm_next
		ld l, (iy + CELDA_MODIFICADA_NUM_CELDA)
		ld a, (iy + CELDA_MODIFICADA_TIPO_CELDA)
		ld (hl), a
_updm_next
	ld de, TAM_CELDA_MODIFICADA
	add iy, de
	djnz _updm_loop
	ret

