;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

NUM_OBJETOS_MOCHILA equ 7


.render_objeto_tipo
	db 0
.render_objeto_posicion
	db 0
.array_objetos_mochila:
	repeat NUM_OBJETOS_MOCHILA
		db 0
	rend



.mensaje_pelota:
	db 0
mochila_get_objeto_a:
	ld a, c

mochila_get_objeto_c:
	ld hl, array_objetos_mochila
	ld b, 0
	add hl, bc
	ld a, (hl)
	ret


mochila_hay_espacio:
    ld a, #ff
    listabytes_find array_objetos_mochila, NUM_OBJETOS_MOCHILA
    ret

mochila_reset:
    listabytes_reset array_objetos_mochila, NUM_OBJETOS_MOCHILA, #ff
	xor a
	ld (mensaje_pelota), a
	ret

mochila_add_objeto:
	listabytes_add_byte array_objetos_mochila, NUM_OBJETOS_MOCHILA, #ff 
    ret nz
	ld ixl, a
	ld ixh, e
	ld d, ORDEN_ACTUALIZAR_MOCHILA
	call marcador_anadir_orden

	xor a
	ret
mochila_remove_objeto:
    listabytes_del_byte array_objetos_mochila, NUM_OBJETOS_MOCHILA, #ff
	ret nz

	ld ixh, e
	ld ixl, #ff 
	ld d, ORDEN_ACTUALIZAR_MOCHILA
	call marcador_anadir_orden
    xor a 
    ret


mochila_calc_sprite:
    ld hl, posiciones_objetos
    call get_word_array 
	ldw_indi de 
	add_backbuffer_to d
    ret

mochila_render_update:
	ld a, (render_objeto_tipo)
    cp #ff
    jr z, _mrco_erase

_mrco_paint
	ld a, (render_objeto_posicion)
    call mochila_calc_sprite 

    ld hl, objeto_pantalla_sprite_mini
    jp mochila_render_objeto

_mrco_erase
mochila_render_borrar_objeto:
	ld a, (render_objeto_posicion)
	call mochila_calc_sprite

	ex de, hl
	SetParametrosPintarRectanguloAncho SPRITE_MINI_OBJETO_ANCHO
	push hl
		ld iyl, 6
		call rectangulo_borrar_bloque_n_lineas
	pop hl
	
	
	ld bc, SCREEN_WIDTH-#800-#800
	add hl, bc
	call rectangulo_borrar_bloque_8_lineas
	ret


mochila_render_objeto:
	push iy
		ldw_mv __spr_r_ancho, SPRITE_MINI_OBJETO_ANCHO, bc
		ldw_mv __spr_r_800_ancho, #800-SPRITE_MINI_OBJETO_ANCHO, bc
		ld iyh, SPRITE_MINI_OBJETO_ALTO
		call sprite_render
	pop iy
	RET




mochila_pintar_objeto:
	call mochila_calc_sprite
	
	push de
		ld hl, objeto_pantalla_sprite_mini
		call mochila_render_objeto
	pop de
	ld a, d
	xor #40
	ld d, a
	
	ld hl, objeto_pantalla_sprite_mini
	call mochila_render_objeto
	
	RET



mostrar_mensaje_pelota_si_necesario:
	ld a, (mensaje_pelota)
	cp 1
	ret z

	push ix
	push iy
		VentanaJuego ventana_pelota
	pop iy
	pop ix

	ld hl, mensaje_pelota
	ld (hl), 1
	ret



