;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

OBJETO_NULO equ #ff


OBJ_LLAVE_1			equ 0
OBJ_LLAVE_2			equ 1
OBJ_LLAVE_3			equ 2
OBJ_LLAVE_4			equ 3

OBJ_HOZ				equ 4
OBJ_SIERRA			equ 5
OBJ_TABLA			equ 6
OBJ_ANTIDOTO		equ 7
OBJ_SOBRE			equ 8

OBJ_COMIDA			equ 9
OBJ_AGUA			equ 10

OBJ_ANTORCHA        equ 11

;; objetos obligatorios
OBJ_CUERDA			equ 12
OBJ_TELA			equ 13
OBJ_HACHA			equ 14
OBJ_MAPA			equ 15

OBJ_PELOTA          equ 16






let num_sprite=0
macro z____new_TipoObjeto _id_objeto, _nuevo_sprite
    BeginStruct TIPO_OBJETO
        db _id_objeto
        if "_nuevo_sprite"="1"
            let num_sprite=num_sprite+1
        endif
        dw num_sprite * TAM_SPRITE_OBJETO
        DeclareFieldStruct TIPO_OBJETO, ID, 1
        DeclareFieldStruct TIPO_OBJETO_OFFSET_SPRITE, 2
    EndStruct TIPO_OBJETO
endm



objeto_cargar_dos:
	call objeto_get_num_sprite

	cp OBJ_AGUA-3
	jr z, _objeto_cargar_grande
	cp OBJ_COMIDA-3
	jr z, _objeto_cargar_grande
	
	push af
		call obj_cargar_sprite_mini
	pop af
_objeto_cargar_grande
	call obj_cargar_sprite_grande
	ret


objeto_get_num_sprite:
	cp OBJ_LLAVE_4
	jr_si_a_menor _ocd_llave
_ocd_no_llave
	sub 3
	ret
_ocd_llave
	xor a 
	ret
	
	
obj_cargar_sprite_mini:
		ld bc, TAM_SPRITE_MINI_OBJETO
		ld hl, sprites_objetos_mini_zx0
		ld de, objeto_pantalla_sprite_mini
		call objeto_cargar_priv
		ret


obj_cargar_sprite_grande:	
	ld bc, TAM_SPRITE_GRAN_OBJETO
	ld hl, sprites_objetos_gran_zx0
	ld de, objeto_pantalla_sprite_grande
	call objeto_cargar_priv
	ret
	


objeto_cargar_priv:
	ld (__obj_tam2), bc
	ld (__obj_tam3), bc
	ld (__obj_guardar), de
	
	ld de, #0000  
	__obj_tam1 equ $-2

	push af
		ld de, FIN
		call dzx0
	pop bc 

	ld hl, FIN
	ld de, #0000 
	__obj_tam2 equ $-2
	call array_get_item 
	
	ld de, #0000
	__obj_guardar equ $-2
    ld bc, #0000 
	__obj_tam3 equ $-2
	ldir

	RET
	



