;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.objeto_pantalla_sprite_objeto_id:
    db #ff



.objeto_pantalla:
	new_ObjetoPantalla


.hay_objeto:
	db #00




check_hay_objeto:
	ld a, (hay_objeto)
	cp 1
	ret z




objeto_pantalla_reset:
	ld a, #ff
	ld (objeto_pantalla), a
	ld (objeto_pantalla+1), a
	ld (objeto_pantalla_sprite_objeto_id), a
	ret






objeto_pantalla_cargar_sprite:
    ld (objeto_pantalla_sprite_objeto_id), a
    call objeto_cargar_dos
    ret




objeto_pantalla_actualizar:
	ld iy, objeto_pantalla
	ld bc, (coordenadas_pantalla)
	call format44_join_bytes 

	ld hl, array_objetos_mapa
	ld b, MAX_OBJETOS_MAPA+1 
	ld de, TAM_OBJETO_MAPA
	call array_search_item   
	jr z, _ao_act_encontrado
	
		call objeto_pantalla_reset
		
		xor a
		ld (hay_objeto), a
		ret

_ao_act_encontrado
	ld a, 1
	ld (hay_objeto), a
	inc hl 
	
	ld a, #ff
	cp (hl)
	jr nz, _op_act_con_celda
_op_act_sin_celda
	
	push hl
		call pantalla_get_random_celda_pisable_objeto 
		ld a, l  
	pop hl
    ld (hl), a
_op_act_con_celda
	ld a, (hl)
	ld (iy + T_OBJETO_PANTALLA_CELDA), a   
_ip_act_tipo_objeto
	inc hl  
	ld a, (hl) 
	ld (iy + T_OBJETO_PANTALLA_ID_OBJETO), a   

    call cargar_sprites_objetos_si_necesario

	ld a, (iy + T_OBJETO_PANTALLA_CELDA) 
	

pantalla_poner_objeto:
	call pantalla_get_offset_celda 
	ld hl, SCREEN_WIDTH+SCREEN_WIDTH+SCREEN_WIDTH 
	add hl, de
	ldw_ir iy, T_OBJETO_PANTALLA_OFFSET, hl

	ld hl, celdas_afectadas_objeto
	call celdas_afectadas_reset

	ld a, (iy + T_OBJETO_PANTALLA_CELDA)
	ld iy, celdas_afectadas_objeto
	call ca_calcular_vertical_objeto

	RET




cargar_sprites_objetos_si_necesario:
    
    ld hl, objeto_pantalla_sprite_objeto_id
    cp (hl)
    ret z
		ld (objeto_pantalla_sprite_objeto_id), a
		call objeto_cargar_dos
	ret
	


objeto_pantalla_render_si_necesario:
	debug sw_2
	ld a, (hay_objeto)
	cp 1
	ret nz
	



objeto_pantalla_render:
	ld ix, objeto_pantalla
	ld a, #ff
	cp (ix + T_OBJETO_PANTALLA_ID_OBJETO)
	ret z

	
	ldw_ri de, ix, T_OBJETO_PANTALLA_OFFSET
	add_backbuffer_to d
	ld ix, definicion_celda_tipo_0
	call render_celda_parte_abajo_prv

	
	ld ix, objeto_pantalla
	ld de, objeto_pantalla_sprite_grande
	ldw_ri hl, ix, T_OBJETO_PANTALLA_OFFSET
	add_backbuffer_to h
	call pintar_bloque_6x8_mask 
	ld bc, SALTO_ENTRE_BLOQUES_ZIGZAG
	add hl, bc
	ld de, objeto_pantalla_sprite_grande+TAM_MITAD_SPRITE_GRAN_OBJETO
	call pintar_bloque_6x8_mask

	ret




objeto_pantalla_rencer_celdas_afectadas_delante_si_necesario:
	debug sw_11
	ld a, (hay_objeto)
	cp 1
	ret nz

	RenderCeldasAfectadasDelante celdas_afectadas_objeto	
	ret
