;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


NUM_LLAVES           equ 4
NUM_OBJETOS_OBJETIVO equ 4
NUM_ANTORCHAS        equ 1
NUM_PELOTAS          equ 1

MAX_OBJETOS_SIERRA   equ 10
MAX_OBJETOS_HOZ      equ 10
MAX_OBJETOS_TABLA    equ 9
MAX_OBJETOS_SOBRE    equ 8
MAX_OBJETOS_ANTIDOTO equ 6
MAX_OBJETOS_AGUA     equ 10
MAX_OBJETOS_COMIDA   equ 9

MAX_OBJETOS_NORMALES equ MAX_OBJETOS_SIERRA+MAX_OBJETOS_HOZ+MAX_OBJETOS_TABLA+MAX_OBJETOS_SOBRE+MAX_OBJETOS_ANTIDOTO+MAX_OBJETOS_AGUA+MAX_OBJETOS_COMIDA

MAX_OBJETOS_MAPA equ NUM_LLAVES+NUM_OBJETOS_OBJETIVO+NUM_ANTORCHAS+NUM_PELOTAS+MAX_OBJETOS_NORMALES


let _max_objetos_mapa=0
let _max_tipos_objeto=0
macro new_DatosCreacionObjetoMapa _tipo_objeto, _ocurrencias
	let n=_tipo_objeto*16
	let n=n+_ocurrencias
	let _max_objetos_mapa=_max_objetos_mapa+_ocurrencias
	let _max_tipos_objeto=_max_tipos_objeto+1

	db n 
endm



macro new_ObjetoMapa
	BeginStruct OBJETO_MAPA
		FieldStruct OBJETO_MAPA, PANTALLA, 1 
		FieldStruct OBJETO_MAPA, CELDA, 1 
		FieldStruct OBJETO_MAPA, TIPO_OBJETO, 1
	EndStruct OBJETO_MAPA
endm


.array_creacion_objetos_mapa:
	new_DatosCreacionObjetoMapa OBJ_CUERDA,   1
	new_DatosCreacionObjetoMapa OBJ_TELA,     1
	new_DatosCreacionObjetoMapa OBJ_HACHA,    1
	new_DatosCreacionObjetoMapa OBJ_MAPA,     1
	new_DatosCreacionObjetoMapa OBJ_HOZ,      MAX_OBJETOS_HOZ
	new_DatosCreacionObjetoMapa OBJ_SIERRA,   MAX_OBJETOS_SIERRA
	new_DatosCreacionObjetoMapa OBJ_TABLA,    MAX_OBJETOS_TABLA
	new_DatosCreacionObjetoMapa OBJ_ANTIDOTO, MAX_OBJETOS_ANTIDOTO
	new_DatosCreacionObjetoMapa OBJ_SOBRE,    MAX_OBJETOS_SOBRE
	new_DatosCreacionObjetoMapa OBJ_COMIDA,   MAX_OBJETOS_COMIDA
	new_DatosCreacionObjetoMapa OBJ_AGUA,     MAX_OBJETOS_AGUA


MAX_TIPOS_OBJETO_REPARTIR equ _max_tipos_objeto



.array_objetos_mapa:
.om_pelota:            
	repeat NUM_PELOTAS
		new_ObjetoMapa
	rend
.om_llaves:            
	repeat NUM_LLAVES
		new_ObjetoMapa
	rend
.om_antorcha:			
	repeat NUM_ANTORCHAS
		new_ObjetoMapa
	rend
.om_objetos_objetivo:	
	repeat NUM_OBJETOS_OBJETIVO
		new_ObjetoMapa
	rend
.om_normales:			
	repeat MAX_OBJETOS_NORMALES
		new_ObjetoMapa
	rend
.objeto_comodin:   
	new_ObjetoMapa

fin_array_objetos_mapa equ $


objetos_mapa_reset:
	listabytes_reset array_objetos_mapa, fin_array_objetos_mapa-array_objetos_mapa, #ff
    ret




objetos_mapa_repartir:
	call repartir_pelota
	call repartir_llaves
	call repartir_antorcha
	
	
repartir_objetos_normales:
	ld b, MAX_TIPOS_OBJETO_REPARTIR 
	ld hl, array_creacion_objetos_mapa
	ld ix, om_objetos_objetivo 
_om_r_loop
	ld a, (hl) 

	exx 
		call format44_split_byte 
		ld a, d 
		ld (__om_objeto), a
		ld b, e 
		call objetos_mapa_repartir_tipo_objeto
	exx
	
	inc hl
	djnz _om_r_loop

	RET
	


repartir_pelota:
	ld e, TAM_ARRAY_PANTALLAS_PELOTA
	call random_max_e
	ld b, 0
	ld c, a
	ld hl, array_pantallas_pelota
	add hl, bc
	ld a, (hl)
	
	ld hl, om_pelota
	ld (hl), a
	inc hl
	inc hl
	ld (hl), OBJ_PELOTA
	
	RET
	
	
	
	
repartir_antorcha:
	call objetos_mapa_get_pantalla_random_libre
	listabytes_find array_pantallas_sin_antorcha, TAM_ARRAY_PANTALLAS_SIN_ANTORCHA
	jr z, repartir_antorcha
	
	ld hl, om_antorcha
	ld (hl), a 
	inc hl
	inc hl
	ld (hl), OBJ_ANTORCHA
	
	RET


	
	
repartir_llaves:
	ld ix, om_llaves
	ld iyl, OBJ_LLAVE_4 
	
_rll_loop
	call objetos_mapa_get_pantalla_random_libre 
	listabytes_find array_pantallas_sin_llave, TAM_ARRAY_PANTALLAS_SIN_LLAVE 
	jr z, _rll_loop
	
	ld (ix + OBJETO_MAPA_PANTALLA), a 

	ld a, iyl
	ld (ix + OBJETO_MAPA_TIPO_OBJETO), a 
	
	ld bc, TAM_OBJETO_MAPA
	add ix, bc
	
	dec iyl
	jp p, _rll_loop 
	
	
	ld a, r 
	and %00000011
	ld hl, TAM_OBJETO_MAPA
	call multiplicar 
	ld bc, om_llaves
	add hl, bc
	
	call random
	and %00000001
	or a
	jr z, _pant_opc1
	
		ld (hl), PANTALLA1_CUEVA_LLAVE
		ret
_pant_opc1
		ld (hl), PANTALLA2_CUEVA_LLAVE
		ret
	


	


objetos_mapa_repartir_tipo_objeto:
_om_rp_loop
	push bc
		call objetos_pantalla_ubicar_objeto_en_pantalla_al_azar
		ld de, TAM_OBJETO_MAPA
		add ix, de
	pop bc
	djnz _om_rp_loop
	ret




objetos_pantalla_ubicar_objeto_en_pantalla_al_azar:
	call objetos_mapa_get_pantalla_random_libre  
	ld (ix + OBJETO_MAPA_PANTALLA), a 
	ld (ix + OBJETO_MAPA_CELDA), #ff 
	ld (ix + OBJETO_MAPA_TIPO_OBJETO), #ee 
	__om_objeto equ $-1 
	ret




objetos_mapa_get_pantalla_random_libre:
	call objetos_mapa_get_pantalla_random 
	listabytes_isin array_pantallas_sin_objeto, TAM_ARRAY_PANTALLAS_SIN_OBJETO
	jr z, objetos_mapa_get_pantalla_random_libre
	ld c, a
	call objetos_mapa_is_pantalla_ocupada 
	jr z, objetos_mapa_get_pantalla_random_libre
	ld a, c
	ret




objetos_mapa_buscar_pantalla:
objetos_mapa_is_pantalla_ocupada:
    ArraySearch array_objetos_mapa, MAX_OBJETOS_MAPA, TAM_OBJETO_MAPA
    ret




objetos_mapa_get_pantalla_random:
	RandomMax MAPA_TAM_PANTALLAS  
	ld b, MAPA_ANCHO_PANTALLAS
	call format44_get_yx 
	ret




objetos_mapa_reubicar_objeto_pantalla_actual:
    call om_get_pantalla_f44 
    call objetos_mapa_buscar_pantalla
    
    push hl
        call objetos_mapa_get_pantalla_random_libre 
    pop hl 

    ld (hl), a   
    inc hl
    ld (hl), #ff 

    ret




objetos_mapa_eliminar_objeto_pantalla_actual:
    call om_get_pantalla_f44 
    call objetos_mapa_buscar_pantalla 
    ld (hl), #ff
    ret


