;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.pantalla_ambiente:
.conjunto_celdas_primario:
	db #F0

.conjunto_celdas_secundario:
	db #F0

.sumador_conjunto_celdas_secundario:
	db #ff





macro pantalla_GetTile
	ld h, PANTALLA_BYTEH
	ld a, (hl)
endm




pantalla_reset:
	ld bc, #f0f0
	ld (conjunto_celdas_primario), bc
	ret
	


pantalla_get_offset_celda:
	ld hl, array_offsets_tiles
	ld c, a
	ld b, 0
	call get_word_array
	ldw_indi de
	ret

om_get_pantalla_f44:
    ld bc, (coordenadas_pantalla)
    call format44_join_bytes
    ret





PANTALLA_ALTO_MITAD equ PANTALLA_ANCHO*5
PANTALLA_ANCHO_MITAD equ PANTALLA_ANCHO/2
PANTALLA_TAM_MITAD equ PANTALLA_TAM/2

.definicion_rangos_posicion_inicial_canibal:
	db  0, PANTALLA_ALTO_MITAD-1, 0, PANTALLA_TAM_MITAD-1
	db  0, PANTALLA_ALTO_MITAD-1,  PANTALLA_TAM_MITAD, PANTALLA_TAM-1
	db  0, PANTALLA_ANCHO_MITAD-1,  0, PANTALLA_TAM-PANTALLA_ANCHO_MITAD-1
	db  PANTALLA_ANCHO_MITAD, PANTALLA_ANCHO-1,  PANTALLA_ANCHO_MITAD, PANTALLA_TAM-1



.definicion_rangos_posicion_serpiente:
	db  0, PANTALLA_ANCHO-1,  0, PANTALLA_TAM-PANTALLA_ANCHO-PANTALLA_ANCHO-1
	db  0, PANTALLA_ANCHO-1,  PANTALLA_ANCHO+PANTALLA_ANCHO, PANTALLA_TAM-1
	db  0, PANTALLA_ANCHO-3,  0, PANTALLA_TAM-3
	db  2, PANTALLA_ANCHO-1,  2, PANTALLA_TAM-1




pantalla_get_random_celda_serpiente:
	ArrayGetItem definicion_rangos_posicion_serpiente, 4 
	jr _pant_random_celda_enemigo


pantalla_get_random_celda_pisable_canibal:
		ArrayGetItem definicion_rangos_posicion_inicial_canibal, 4

_pant_random_celda_enemigo
	ld a, (hl)
	ld ixl, a

	inc hl
	ld a, (hl)
	ld ixh, a

	inc hl
	ld c, (hl)

	inc hl
	ld b, (hl)

	jr pantalla_get_random_celda_pisable



pantalla_get_random_celda_pisable_objeto:
	ld ixh, PANTALLA_ANCHO-2
	ld ixl, 1
	ld b, PANTALLA_TAM-PANTALLA_ANCHO-1
	ld c, PANTALLA_ANCHO+1
	




pantalla_get_random_celda_pisable:
	
	ld a, b
	sub c
	ld e, a 
	ld d, b 
		call random_max_e 
	ld b, d
	add c
	ld l, a 
	ld h, PANTALLA_BYTEH 

	push bc
		ld b, PANTALLA_ANCHO
		call format44_get_y_x 
		ld d, a 
	pop bc
_pgrcp_loop
	ld a, l 
	cp b
	jr_si_A_mayor _p_celda_max

	ld a, d 
	cp ixh 
	jr_si_A_mayor _p_siguiente
	cp ixl 
	jr_si_A_menor _p_siguiente

	
	ld a, (hl)
	cp 0 
	ret z
		
_p_siguiente  
	inc d
	ld a, d
	cp PANTALLA_ANCHO
	jr nz, _p_incl
		ld d, 0
_p_incl
	inc l
	jr _pgrcp_loop
_p_celda_max
	ld l, c 
	ld d, ixl 
	jr _pgrcp_loop




macro new_CambioPantalla  dire, inc_ord_celda, inc_x_celda, inc_y_celda, inc_x_pant, inc_y_pant, inc_yx_pant, fn_borrarPant, fn_pintarPant
	BeginStruct CAMBIO_PANTALLA
		db inc_ord_celda  
		db inc_x_celda    
		db inc_y_celda
		db inc_x_pant
		db inc_y_pant
		db inc_yx_pant
		dw fn_borrarPant
		dw fn_pintarPant
		DeclareFieldStruct CAMBIO_PANTALLA, INC_CELDA_ORD, 1
		DeclareFieldStruct CAMBIO_PANTALLA, INC_CELDA_X, 1
		DeclareFieldStruct CAMBIO_PANTALLA, INC_CELDA_Y, 1
		DeclareFieldStruct CAMBIO_PANTALLA, INC_PANT_X, 1
		DeclareFieldStruct CAMBIO_PANTALLA, INC_PANT_Y, 1
		DeclareFieldStruct CAMBIO_PANTALLA, INC_PANT_YX, 1
		DeclareFieldStruct CAMBIO_PANTALLA, FN_BORRAR_PANT, 2
		DeclareFieldStruct CAMBIO_PANTALLA, FN_PINTAR_PANT, 2
	EndStruct CAMBIO_PANTALLA
endm



.incrementos_x_cambio_de_pantalla:
new_CambioPantalla DIRECCION_ARRIBA   , PANTALLA_TAM-PANTALLA_ANCHO,                 0, PANTALLA_ALTO-1,  0, -1, -16, borrar_pantalla_abajo_arriba     , presentar_pantalla_abajo_arriba
new_CambioPantalla DIRECCION_ABAJO    , PANTALLA_ANCHO-PANTALLA_TAM,                 0, 1-PANTALLA_ALTO,  0,  1,  16, borrar_pantalla_arriba_abajo     , presentar_pantalla_arriba_abajo
new_CambioPantalla DIRECCION_IZQUIERDA, PANTALLA_ANCHO-1           ,  PANTALLA_ANCHO-1,               0, -1,  0,  -1, borrar_pantalla_derecha_izquierda, presentar_pantalla_derecha_izquierda
new_CambioPantalla DIRECCION_DERECHA  , 1-PANTALLA_ANCHO           ,  1-PANTALLA_ANCHO,               0,  1,  0,   1, borrar_pantalla_izquierda_derecha, presentar_pantalla_izquierda_derecha




pantalla_modificar:
	ld a, (pantalla_ambiente)
	cp AMB_PLAYA
	jp z, pantalla_modificar_playa
	cp AMB_CABANA
	jr z, pantalla_modificar_cabana
	RET





pantalla_modificar_cabana:
	ld a, (num_puertas_visitadas)
	cp 1
	jr z, _pmc_primera
	cp 2
	jr z, _pmc_segunda
	ret
_pmc_primera                 
	ld l, 44 
	ld h, PANTALLA_BYTEH
	ld (hl), ID_CELDA_NATIVA
	RET
_pmc_segunda                
	ld hl, objeto_comodin
	ld a, (pantalla_mapa_yx)
	ld (hl), a 
	call random    
	and %00000011  
	add a, 28      

	inc hl 
	ld (hl), a
	inc hl 

	call random
	and %00000011 
	add a, OBJ_ANTIDOTO
	ld (hl), a

	ld a, 1
	ld (hay_objeto), a

	RET





pantalla_modificar_playa:
	ld iyl, 5  
_pmp_loop
	call pant_get_celda_pisable_random
	ld h, PANTALLA_BYTEH
	ld (hl), 8 
	dec iyl
	jr nz, _pmp_loop
	RET	
	




pant_get_celda_pisable_random:
	ld h, PANTALLA_BYTEH
	ld e, PANTALLA_TAM
_pgcp_loop
	call random_max_e
	ld l, a
	ld a, (hl)
	cp 0
	ret z
	jr _pgcp_loop
	
	



pantalla_poner_canibal_particular:
	ld a, (pantalla_ambiente)
	cp AMB_CABANA
	ret nz

	ld a, (num_puertas_visitadas)
	cp 1    
	ret nz
	
	ld a, 32
	ld (enemigo_celda_num), a

	ld b, PANTALLA_ANCHO
	call format44_get_y_x 
	ld b, c  
	ld c, a  
	ld (enemigo_celda), bc

	call canibal_set
	call canibal_reset_ia
	
	ld a, DIRECCION_ABAJO
	jp canibal_cargar_sprites

	

