;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


DIST_COLISION_X equ 4
DIST_COLISION_Y equ 12


.sprites_descomprimidos
	db 0

.sprites_descomprimidos_jugador:
	db #ff

.sprites_descomprimidos_canibal:
	db #ff


PER_CELDA_X equ 0
PER_CELDA_Y equ 1
PER_CELDA_NUM equ 2
PER_COORD equ 3
PER_DIRECCION equ 5
PER_ANIMACION equ 6
PER_CELDA_REF equ 7
PER_CELDAS_AFECTADAS equ 11 





personaje_calcular_coordenadas:
	push bc
		ld a, c
		ld hl, SPR_SPRITE_PERSONAJE_ANCHO*2
		call multiplicar 
		ld (ix + COORDENADA_X), l 
	pop bc

	ld a, b
	ld hl, ALTO_BASE_TILE_BYTES
	call multiplicar

	ld bc, COORDENADA_Y_INICIO_PARA_PERSONAJE
	add hl, bc
	ld (ix + COORDENADA_Y), l 

	RET





macro CalcularCoordenadasJugador
	ld bc, (jugador_celda)
	ld ix, coordenadas_jugador
	call personaje_calcular_coordenadas
endm


macro CalcularCoordenadasCanibal
	ld bc, (enemigo_celda)
	ld ix, coordenadas_enemigo
	call personaje_calcular_coordenadas
endm


macro ResetJugador
	ld ix, PERSONAJE_JUGADOR
	ld hl, celdas_afectadas_jugador
	call personaje_reset
endm


macro ResetEnemigo
	ld ix, PERSONAJE_ENEMIGO
	ld hl, celdas_afectadas_enemigo
	call personaje_reset
endm




personaje_reset:
	ld (ix + PER_ANIMACION), #ff
	ld (ix + PER_CELDA_REF), #ff
	call celdas_afectadas_reset
	ret
	

update_jugador_celda_num:
	ld bc, (jugador_celda)
	ld e, PANTALLA_ANCHO
	call format44_get_secuencial 
	ld (jugador_celda_num), a
	ret





get_sprites_jugador:
	ld hl, sprites_descomprimidos_jugador
	cp (hl)
	ret z
	
	ld (hl), a
	ld hl, array_sprites_jugador
	ld de, sprites_jugador
	jr get_sprites_personaje



get_sprites_canibal:
	ld hl, sprites_descomprimidos_canibal
	cp (hl)
	ret z
	
	ld (hl), a
	ld hl, array_sprites_canibal
	ld de, sprites_canibal
	
get_sprites_personaje:
	call get_word_array
	ldw_indi bc
	ldw_rr hl, bc
	call dzx0
	
	ld a, 1
	ld (sprites_descomprimidos), a

	ret


get_sprites_canibal_billete:
	ld hl, sprites_canibal_billete_zx0
	ld de, sprites_canibal
	call dzx0
	ld a, #ff
	ld (sprites_descomprimidos_canibal), a
	ret
	



personajes_render_personajes:
	ld hl, coordenadas_enemigo+1 
	
	call check_hay_canibal
	jr z, _prp_set_canibal
	call check_hay_serpiente
	jr z, _prp_set_serpiente
		debug sw_16
		call render_jugador
		ret
_prp_set_serpiente
	ld de, render_serpiente
	jr _prp_comun
_prp_set_canibal
	ld de, render_canibal
_prp_comun
	ld (__prpv_fn_render_enemigo1), de
	ld (__prpv_fn_render_enemigo2), de




personajes_render_personajes_prv:
	ld a, (coordenadas_jugador+1) 
	ld b, (hl) 
	cp b
	jr_si_A_menor _prpv_enemigo_delante
		debug sw_17
		call #0000
		__prpv_fn_render_enemigo1 equ $-2
		debug sw_16
		call render_jugador
		ret
_prpv_enemigo_delante
	debug sw_16
	call render_jugador
	debug sw_17
	call #0000
	__prpv_fn_render_enemigo2 equ $-2
	ret







personajes_render_celdas_afectadas_detras:
	debug SW_4
	RenderCeldasAfectadasDetras celdas_afectadas_jugador
	
	call check_hay_canibal
	jr z, _prca_detras_render
	call check_hay_serpiente
	ret nz
_prca_detras_render
	debug SW_5
	RenderCeldasAfectadasDetras celdas_afectadas_enemigo
	
	ret


	
personajes_render_celdas_afectadas_delante:
	debug SW_4
	RenderCeldasAfectadasDelante celdas_afectadas_jugador

	call check_hay_canibal
	jr z, _prca_delante_render
	call check_hay_serpiente
	ret nz
_prca_delante_render
	debug SW_5
	RenderCeldasAfectadasDelante celdas_afectadas_enemigo
	
	ret



	

personaje_avanzar:
	ld (__pa_celda_num), a
	ld (__pa_coordenadas_personaje), de
	
	ArrayGetItem array_definicion_anim_y_ccaa, TAM_DATOS_MOV  
	push hl
	pop ix    

	ldw_ri bc, ix, DATOS_MOV_INCR_ANIM
	ldw_ir iy, ANIMACION_INCREMENTOS, bc
	
	ld a, (ix + DATOS_MOV_PASOS_ANIM)
	ld (iy + ANIMACION_PASOS), a
	
	ld a, #00
	__pa_celda_num equ $-1
	add (ix + DATOS_MOV_CELDA_REF)
	ld (__pa_celda_referencia), a
	
	ldw_ri bc, ix, DATOS_MOV_FN_CALCULAR_CCAA
	ld (__pa_call_calcular_ccaa), bc

	ld ix, #0000 
	__pa_coordenadas_personaje equ $-2
	call animacion_actualizar

	ld b, #00  
	__pa_celda_referencia equ $-1
	ld de, #0000 
	__pa_call_calcular_ccaa equ $-2  

	ld a, #99
	personaje_avanzar_quien equ $-1
	cp 0
	jr z, _p_avanzar_jugador
	cp 1
	jr z, _p_avanzar_enemigo

_p_avanzar_jugador
	ld a, b
	ld (jugador_celda_referencia), a  
	ld (jugador_ca_func_calcular), de 
	RET
_p_avanzar_enemigo
	ld a, b
	ld (enemigo_celda_referencia), a  
	ld (enemigo_ca_func_calcular), de 
	RET

	
personaje_check_calcular_celdas_afectadas:
	ld a, (ix + PERSONAJE_CELDA_REFERENCIA)
	cp #ff
	ret z
	
	push hl
	pop iy

	ex af, af'
		call celdas_afectadas_reset
	ex af, af'
	
	ldw_ri bc, ix, PERSONAJE_FUNC_CALCULAR_CA
	ld (__pcca_func_ca), bc
	
	ld h, #ff
	ld (ix + PERSONAJE_CELDA_REFERENCIA), h
	
	call #0000 
	__pcca_func_ca equ $-2
	
	RET
	
	
	






hay_colision_canibal:
	call get_modo_canibal
	jr z, _hcp_evaluar 
		scf
		ccf
		ret
_hcp_evaluar
	ld bc, (coordenadas_jugador)  
	ld de, (coordenadas_enemigo)  

	ld a, b
	sub d
	call absA

	cp DIST_COLISION_Y+1
	ret_si_A_mayor_o_igual

	ld a, c
	sub e
	call absA

	cp DIST_COLISION_X+1
	ret

