;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

ventana_mostrar:
	dw 0

ventana_hay_que_mostrar:
	ld hl, (ventana_mostrar)
	xor a
	or h
	or l
	ret
	
esperar_tecla:
	call waitVSYNC
	call random
	call scan_keyboard
	call is_any_key_pressed 
	jr z, esperar_tecla
	RET


ventana_juego:
	call ventana_render
	EsperarSegundos 1
	call esperar_tecla
	call ventana_restaurar
	ld bc, 0
	ld (ventana_mostrar), bc
	RET



.vr_offset:
	dw 0
.vr_alto:
	db 0
.vr_ancho:
	db 0



ventana_restaurar:
	ld a, (vr_alto)
	ld iyh, a
	
	ld a, (vr_ancho)
	ld (__rcb_ancho), a
	
	call calc_800_a
	ld (__rcb_800_ancho), hl
	
	ld hl, (vr_offset)
	add_backbuffer_to h
	
	call ph_copiar_rectangulo_alto
	ret

ventana_render:

if VENTANAS_COMPRIMIDAS=1
	push hl
		ld hl, ventanas_zx0
		ld de, sprites_celdas_primarias
		call dzx0
		call text_render_pre
	pop hl
	
else		
	push hl
		call text_render_pre
	pop hl
endif

	call ventana_pintar_cuadro:
_ventana_render_loop
	inc hl 
	ld a, (hl)
	cp ORDEN_RENDER_TEXTO
	jr z, ventana_render_linea
	cp ORDEN_RENDER_TEXTO_REFERENCIADO
	jr z, ventana_render_linea_ref
	cp ORDEN_CAMBIAR_COLORES
	jr z, ventana_cambiar_colores
	
	call cargar_conjunto_celdas_primario
	call cargar_conjunto_celdas_secundario 
	
	RET
	
	


ventana_cambiar_colores:
	call get_parametros_orden 

	push hl
		ldw_rr hl, de
		call cambiar_colores_fuente  
	pop hl
	
	jp _ventana_render_loop
	
	
	
ventana_render_linea:
	inc hl
	ldw_indi de
	add_videopage_to d
	
	inc hl
	call pintar_texto

	jp _ventana_render_loop
	


ventana_render_linea_ref:
	call get_parametros_orden 
	
	push hl
		ldw_rr hl, bc
		add_videopage_to d
		call pintar_texto  
	pop hl
	
	jp _ventana_render_loop
	
	
	


get_parametros_orden:
	inc hl
	ldw_indi de 
	inc hl
	ldw_indi bc 
	ret




ventana_pintar_cuadro:
	
	ld a, (hl)
	ld (vr_ancho), a
	dec a
	ld (__borr_rect_ancho), a
	
	ex de, hl
		call calc_800_a
		ld (__borr_rect_800_ancho), hl
	ex de, hl
	
	inc hl
	ld a, (hl)
	ld iyh, a
	ld (vr_alto), a
	
	inc hl
	ld c, (hl) 
	inc hl
	ld b, (hl)
	ld (vr_offset), bc
	
	push hl
		ldw_rr hl, bc
		add_videopage_to h
		call ph_borrar_rectangulo_alto
	pop hl
	ret



calc_800_a:
	ld hl, #800
	neg
	ld c, a
	ld b, #ff
	add hl, bc
	ret


