;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.barra:
 db 252,252,252,3,3,3,255,255,255,255,255,255


MAX_DECREMENTADOR_AGUA     equ 275
MAX_DECREMENTADOR_ENERGIA  equ 375
MAX_NIVEL equ 24
BYTES_BARRA_NIVEL equ 12 



.turno_decrementar
	db 0



.nivel_agua
	db MAX_NIVEL

.decrementador_agua
	dw MAX_DECREMENTADOR_AGUA



.nivel_energia
	db MAX_NIVEL

.decrementador_energia
	dw MAX_DECREMENTADOR_ENERGIA




vida_update:
	ld hl, turno_decrementar
	inc (hl)
	bit 0, (hl)
	jr nz, vida_update_energia




vida_update_agua:
	ld bc, (decrementador_agua)
	dec bc
	test_rr_0 bc
	jr nz, _vida_ua_nz
	
	ld bc, MAX_DECREMENTADOR_AGUA
	ld (decrementador_agua), bc

	ld hl, nivel_agua
	dec (hl)

	ld d, ORDEN_ACTUALIZAR_AGUA
	call marcador_anadir_orden

	ret
_vida_ua_nz
	ld (decrementador_agua), bc
	ret



vida_update_energia:
	ld bc, (decrementador_energia)
	dec bc
	test_rr_0 bc
	jr nz, _vida_ue_nz
	
	ld bc, MAX_DECREMENTADOR_ENERGIA
	ld (decrementador_energia), bc

	ld hl, nivel_energia
	dec (hl)

	ld d, ORDEN_ACTUALIZAR_ENERGIA
	call marcador_anadir_orden

	ret
_vida_ue_nz
	ld (decrementador_energia), bc
	ret




vida_agua_is_ok:
	
	ld hl, POS_BARRA_AGUA
	add_videopage_to h
	xor a
	cp (hl) 
	ret



vida_energia_is_ok:
	
	ld hl, POS_BARRA_ENERGIA
	add_videopage_to h
	xor a
	cp (hl) 
	ret




vida_reset:
	call vida_reset_agua
	call vida_reset_energia
	ret




vida_reset_agua:
	ld d, ORDEN_ACTUALIZAR_AGUA
	call marcador_anadir_orden

vida_init_agua:
	ld a, MAX_NIVEL
	ld (nivel_agua), a

	ld bc, MAX_DECREMENTADOR_AGUA
	ld (decrementador_agua), bc

	ret



vida_reset_energia:
	ld d, ORDEN_ACTUALIZAR_ENERGIA
	call marcador_anadir_orden

vida_init_energia:
	ld a, MAX_NIVEL
	ld (nivel_energia), a

	ld bc, MAX_DECREMENTADOR_ENERGIA
	ld (decrementador_energia), bc
	
	ret




vida_render_update_agua:
	
vida_render_agua:
	ld a, (nivel_agua)
	ld de, POS_BARRA_AGUA
	jr vida_render_barra



vida_render_update_energia:
vida_render_energia:
	ld a, (nivel_energia)
	ld de, POS_BARRA_ENERGIA
	jr vida_render_barra




vida_render_barra:
	ld ixh, a
		add_backbuffer_to d
		ld iyh, d
		ld iyl, e
		ld hl, barra
		ld bc, BYTES_BARRA_NIVEL
		ldir
	ld a, ixh

	ld b, a     
	ld c, a
	ld a, MAX_NIVEL
	sub a, b
	
	jr z, _vrb_copiar_lineas

	rra 
	or a 
	jr z, _vrb_impar
	ld b, a 
	xor a 
	
_vrb_lup
	dec de
	ld (de), a
	djnz _vrb_lup
_vrb_impar
	bit 0, c
	jr z, _vrb_copiar_lineas
	dec de
	ld a, (de)
	and %10101010
	ld (de), a

_vrb_copiar_lineas
	ldw_rr de, iy
	ldw_rr hl, de   
	ld bc, #800
	add hl, bc
	ex de, hl   
	ld a, 5 
	call vida_copiar_lineas
	ex de, hl
		ld bc, -BYTES_BARRA_NIVEL -#800-#800-#800-#800-#800-#800-#800 +SCREEN_WIDTH
		add hl, bc
	ex de, hl
	ld a, 6 



vida_copiar_lineas:
   push hl
      ld bc, BYTES_BARRA_NIVEL
      ldir
   pop hl
   dec a
   jr z, _vcl_salir
   ex de, hl
      ld bc, #800-BYTES_BARRA_NIVEL
      add hl, bc
   ex de, hl
   jr vida_copiar_lineas
_vcl_salir
 or 1
 ret





vida_picadura_serpiente:
	ld a, MAX_DECREMENTADOR_AGUA
	ld hl, decrementador_agua
	ld de, nivel_agua
	ld b, BAJON_PICADURA_NIVEL_AGUA
	call vida_picadura_prv

	ld a, MAX_DECREMENTADOR_ENERGIA
	ld hl, decrementador_energia
	ld de, nivel_energia
	ld b, BAJON_PICADURA_NIVEL_ENERGIA
	call vida_picadura_prv

	ld d, ORDEN_ACTUALIZAR_AGUA
	call marcador_anadir_orden

	ld d, ORDEN_ACTUALIZAR_ENERGIA
	call marcador_anadir_orden

	RET




vida_picadura_prv:
	ld (hl), a

	ld a, (de)
	sub b
	jp_si_signo_positivo _vida_pos
		xor a
_vida_pos
	ld (de), a
	ret

