;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; https://www.youtube.com/watch?v=DWmSR1EPvt0&t=1590s
;; https://www.youtube.com/watch?v=Y70WWi3zbcE
;; https://www.youtube.com/watch?v=QqSLwMz6yG4
;; https://www.youtube.com/watch?v=avHJYjYCmXU&t=25s
;; https://www.youtube.com/watch?v=UMgja5zy92U
;; https://www.youtube.com/watch?v=Ka40LTI6NMM
;; https://www.youtube.com/watch?v=ZiXyjElFwzU



NUM_VSYNC_ESPERA equ 25 

MODO_JUEGO equ 0
MODO_MENU  equ 1

COLOR_CIELO equ SW_23
COLOR_AGUA  equ SW_11


macro RefreshPlayMusic
	ld a, (hay_musica)
	cp 0
	jr z, _no_music
		push ix
		push iy
		push de
		push hl
		ex af, af'
		push af
		exx 
			push bc 
			push de 
			push hl 
				
				call cpct_akp_musicPlay_asm
				
			pop hl 
			pop de 
			pop bc 
		exx
		pop af
		ex af, af'
		pop hl
		pop de
		pop iy
		pop ix
	_no_music
endm



.numero_interrupcion:
	db -1

.modo:
	db MODO_JUEGO
	
	


macro SetFuncionInterrupcion direccion
	ld bc, direccion
	ld (#39), bc
endm

	
	
interrupcion_1:
	push af
	push bc 
		SetFuncionInterrupcion interrupcion_2
		
		
			ld a, (modo)
			cp MODO_JUEGO
			jr z, _s1
				
				ld a, COLOR_CIELO
				ld c, 0
				call set_ink
				call set_border_color

				push hl
				push de
				call animar_ola
				pop de
				pop hl

	_s1
		

if DEBUG_INTERRUPCION=1
	ld a, SW_13
	call set_border_color
endif

	pop bc
	pop af
	ei
	reti
	
	

interrupcion_2:
	push af
	push bc


if DEBUG_MUSIC=1
	ld a, SW_2
	call set_border_color
endif


	RefreshPlayMusic


if DEBUG_MUSIC=1
	ld a, (modo)
	cp MODO_JUEGO
	jr z, _b_mjuego
	ld a, COLOR_CIELO
	jr _b_sb
_b_mjuego
	ld a, SW_0
_b_sb
	call set_border_color
endif



if DEBUG_INTERRUPCION=1
	ld a, SW_9
	call set_border_color
endif


	SetFuncionInterrupcion interrupcion_3
	
	pop bc
	pop af
	ei
	reti



interrupcion_3:
	
	push bc
	SetFuncionInterrupcion interrupcion_4
if DEBUG_INTERRUPCION=1
	push af
		ld a, SW_3
		call set_border_color
	pop af
endif
	pop bc
	
	ei
	reti



interrupcion_4:
	
	push bc
if DEBUG_INTERRUPCION=1
	push af
		ld a, SW_4
		call set_border_color
	pop af
endif
	SetFuncionInterrupcion interrupcion_5
	pop bc
	
	ei
	reti


	
interrupcion_5:
	push af
	push bc
	
		SetFuncionInterrupcion interrupcion_6

		if DEBUG_INTERRUPCION=1
			ld a, SW_5
			call set_border_color
		endif

		ld a, (modo)
		cp MODO_MENU
		jr z, _s5menu
_s5juego
		ld a, (efectos)
		or a 
		jr nz, _s5_fadeout
_s5salir
	pop bc
	pop af
	ei
	reti
_s5_fadeout
		push hl
			call do_fade_out
		pop hl
		jr _s5salir
_s5menu
		ld a, COLOR_AGUA
		ld c, 0
		call set_ink
		call set_border_color
		jr _s5salir




	
interrupcion_6:
	
	push bc
if DEBUG_INTERRUPCION=1
	push af
		ld a, SW_7
		call set_border_color
	pop af
endif
	SetFuncionInterrupcion interrupcion_1
	pop bc
	
	ei
	reti

	

set_int_handler:
	ei
	im 1
	call waitVSYNC
	halt
	halt
	call waitVSYNC
	di
	
	ld a, #c3 
	ld (#38), a
	
	SetFuncionInterrupcion interrupcion_1
	
	ei
	ret
	


	



waitVSYNC:	
   ld  b, #F5
wvs_wait:
   in  a,(c)         
   rra               
   jr  nc, wvs_wait  

   ret               


espera:
	ld c, NUM_VSYNC_ESPERA
_esp_loop
	call waitVSYNC 
	halt
	dec c
	jr nz, _esp_loop
	dec d
	jr nz, espera
	ret




macro Esperar _num_medio_segundo
	ld d, _num_medio_segundo
	call espera
endm



macro EsperarSegundos _num_segundos
	ld d, _num_segundos*2
	call espera
endm


