;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.frame_transicion_menu_partida:
	db 0

.volumen_transicion_menu_partida:
	db 0


inicio_juego:

	call waitVSYNC
	
	ld hl, modo
	ld (hl), #ff  
	call set_pantalla_negra
	
	ld hl, modo
	ld (hl), MODO_TRANSICION

	ld hl, frame_transicion_menu_partida
	ld (hl), 30 
	
	ld hl, volumen_transicion_menu_partida
	ld (hl), 0
	
	call reset_partida
	call inicio_partida

	ld hl, modo
	ld (hl), MODO_JUEGO
	



bucle_juego:

	call cambiar_pagina_visible
	call waitVSYNC

	xor a
	ld (sprites_descomprimidos), a
	ld (tecla_fire_pulsada), a
	
	call incrementar_fire_contador_frames

	call animacion_mar
	
	call juego_render_personajes
	
	call ventana_hay_que_mostrar
	call nz, ventana_juego
		

	ld ix, PERSONAJE_JUGADOR
	ld hl, celdas_afectadas_jugador
	call personaje_check_calcular_celdas_afectadas
	ld ix, PERSONAJE_ENEMIGO
	ld hl, celdas_afectadas_enemigo
	call personaje_check_calcular_celdas_afectadas


	call is_objetivo_conseguido
	jp z, objetivo_conseguido

	xor a
	call vida_agua_is_ok
	jp z, juego_sin_agua
	call vida_energia_is_ok
	jp z, juego_sin_energia

	call hay_colision_canibal
	call c, juego_colision_canibal

	call hay_colision_serpiente
	call z, juego_colision_serpiente

	call anadir_pisada_playa  

	
	debug sw_15
	ld a, (animacion_jugador + ANIMACION_PASOS)
	or a 
	jr_si_iguales _scan_keyboard
		AnimarJugador
		
		ld a, (pantalla_ambiente)
		cp AMB_CUEVA
		jr nz, _fin_turno_jugador
			ld a, 1 
			call cpct_akp_SFXGetInstrument_asm 
			xor a
			cp l
			jr nz, _fin_turno_jugador
			ld l, SFX_PASOS
			call play_sfx
		jr _fin_turno_jugador

_scan_keyboard
		di
		call scan_keyboard
		ei
		call test_teclas_juego
_fin_turno_jugador

	debug sw_6
	call turno_canibal

	debug sw_2
	call marcador_render_update
	debug sw_0

	call vida_update
	ld hl, reloj_partida
	call reloj_inc_tick


	JP bucle_juego



juego_render_personajes:
	call personajes_render_celdas_afectadas_detras
	call objeto_pantalla_render_si_necesario
	call personajes_render_personajes
	call objeto_pantalla_rencer_celdas_afectadas_delante_si_necesario
	call personajes_render_celdas_afectadas_delante
	RET


