;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


macro SetDireccionPersonaje _dire
	ld_a _dire
	jp set_direccion_personaje
endm




accion_arriba:
	ld a, (tecla_fire_pulsada)
	or a
	jr nz, _aarr_dirigir 
	
	CalcularCeldaPre -PANTALLA_ANCHO, 0, -1
	ld a, DIRECCION_ARRIBA
	jr __accion__
_aarr_dirigir
	SetDireccionPersonaje DIRECCION_ARRIBA


accion_abajo:
	ld a, (tecla_fire_pulsada)
	or a
	jr nz, _aaba_dirigir 
	
	CalcularCeldaPre PANTALLA_ANCHO, 0, 1
	ld a, DIRECCION_ABAJO
	jr __accion__
_aaba_dirigir
	SetDireccionPersonaje DIRECCION_ABAJO


accion_izquierda:
	ld a, (tecla_fire_pulsada)
	or a
	jr nz, _aizq_dirigir 
	
	CalcularCeldaPre -1, -1, 0
	ld a, DIRECCION_IZQUIERDA
	jr __accion__
_aizq_dirigir
	SetDireccionPersonaje DIRECCION_IZQUIERDA



_ader_dirigir
	SetDireccionPersonaje DIRECCION_DERECHA

accion_derecha:
	ld a, (tecla_fire_pulsada)
	or a
	jr nz, _ader_dirigir 
	
	CalcularCeldaPre 1, 1, 0
	ld a, DIRECCION_DERECHA



__accion__:
	ld (direccion_jugador), a
	call get_sprites_jugador
	
	ld a, (jugador_celda_pre_x)
	cp PANTALLA_ANCHO
	jr z, _cambia_de_pantalla
	cp #ff
	jr z, _cambia_de_pantalla

	ld a, (jugador_celda_pre_y)
	cp PANTALLA_ALTO
	jr z, _cambia_de_pantalla
	cp #ff
	jr z, _cambia_de_pantalla

	jp _misma_pantalla

	
_cambia_de_pantalla
	call obtener_datos_cambio_pantalla

	ld a, (jugador_celda_num)
	ld b, (ix + CAMBIO_PANTALLA_INC_CELDA_ORD)
	add b
	ld (jugador_celda_num), a

	ld a, (jugador_celda_x)
	ld b, (ix + CAMBIO_PANTALLA_INC_CELDA_X)
	add b
	ld (jugador_celda_x), a

	ld a, (jugador_celda_y)
	ld b, (ix + CAMBIO_PANTALLA_INC_CELDA_Y)
	add b
	ld (jugador_celda_y), a

	ld a, (pantalla_mapa_x)
	ld b, (ix + CAMBIO_PANTALLA_INC_PANT_X)
	add b
	ld (pantalla_mapa_x), a

	ld a, (pantalla_mapa_y)
	ld b, (ix + CAMBIO_PANTALLA_INC_PANT_Y)
	add b
	ld (pantalla_mapa_y), a

	ld a, (pantalla_mapa_yx)
	ld b, (ix + CAMBIO_PANTALLA_INC_PANT_YX)
	add b
	ld (pantalla_mapa_yx), a
	
	push af
	push bc
	push de
	push ix
	push iy
		call juego_render_personajes_1_frame
	pop iy
	pop ix
	pop de
	pop bc
	pop af

	call establecer_efectos_pantalla
	call cambiar_pantalla

	scf
	ret




_misma_pantalla
_acc_test_flags
	ld a, (jugador_celda_pre)
	ld l, a
	pantalla_GetTile
	
	call get_tile 

	ld a, (ix + CELDA_FLAGS)

	bit CELDA_BIT_PISABLE, a
	jp nz, _acc_celda_pisable

	bit CELDA_BIT_CORTABLE_HOZ, a
	jp nz, _acc_celda_cortable_hoz

	bit CELDA_BIT_CORTABLE_SIERRA, a
	jp nz, _acc_celda_cortable_sierra

	bit CELDA_BIT_NAVEGABLE, a
	jp nz, _acc_celda_navegable

	bit CELDA_BIT_TELETRANSPORTE, a
	jp nz, _acc_celda_teletransporte

	bit CELDA_BIT_PUERTA, a
	jp nz, _acc_celda_puerta  

	bit CELDA_BIT_FUNCION, a
	jp nz, celda_funcion


_misma_pantalla_nada
	SetCarryFlag 0
	ret




set_direccion_personaje:
	ld (direccion_jugador), a
	call get_sprites_jugador
	RET



avanzar:
_acc_celda_pisable

	ld a, (jugador_celda_pre)
	ld (jugador_celda_num), a

	ld a, (jugador_celda_pre_x)
	ld (jugador_celda_x), a

	ld a, (jugador_celda_pre_y)
	ld (jugador_celda_y), a



	xor a
	ld (personaje_avanzar_quien), a
	ld a, (direccion_jugador)
	ld b, a
	ld a, (jugador_celda_num)
	ld de, coordenadas_jugador
	ld hl, celdas_afectadas_jugador
	ld iy, animacion_jugador
	call personaje_avanzar


_comprobar_si_hay_objeto
	
	ld a, (jugador_celda_num)
	ld ix, objeto_pantalla
	cp (ix + T_OBJETO_PANTALLA_CELDA) 
	jr nz, _avanzar_salir 

_test_objeto
    ld a, (ix + T_OBJETO_PANTALLA_ID_OBJETO)
    add DISTINTIVO_CELDA   

    push af 
        call mochila_hay_espacio 
    pop bc  
	ld a, b 
    jr nz, _got_buscar
        add a, REQ_HUECO_MOCHILA_SI  
_got_buscar
    listabytes_find array_definiciones_objeto_accion, MAX_DEFINICIONES_OBJETOS_ACCIONES*2 
    jr nz, _avanzar_salir
        ld A, (hl)  

	bit BIT_ANADIR_MOCHILA, a
	call nz, anadir_objeto_a_mochila
	bit BIT_CONSUMIR_OBJ, a
	call nz, consumir_objeto
	bit BIT_ELIMINAR, a
	call nz, eliminar_objeto_del_mapa
	bit BIT_REUBICAR, a
	call nz, reubicar_objeto_en_mapa

	and MASK_SONIDO
	or a
	jr z, _no_sonido
		ld l, a
		call play_sfx
	
_no_sonido

	call objeto_pantalla_reset
	ResetCeldasAfectadas celdas_afectadas_objeto

_avanzar_salir
	SetCarryFlag 1
	ret





anadir_objeto_a_mochila:
	push af
		ld a, (ix + T_OBJETO_PANTALLA_ID_OBJETO)

		cp OBJ_PELOTA
		jr z, _aoam_pelota
		jr _aoam_anadir
_aoam_pelota
			push af
				ld l, SFX_COGER_LLAVE
				call play_sfx
				call mostrar_mensaje_pelota_si_necesario
_aoam_no_visualizar_msj_pelota
			pop af
_aoam_anadir
			ld d, a
			call mochila_add_objeto
	pop af
	
	ret





consumir_objeto:
	push af
		ld a, (ix + T_OBJETO_PANTALLA_ID_OBJETO)
		cp OBJ_AGUA
		jr z, _consumir_agua
		cp OBJ_COMIDA
		
_consumir_comida
		call vida_reset_energia
		pop af
		ret
_consumir_agua
		call vida_reset_agua
		pop af
		ret




reubicar_objeto_en_mapa:
	push af
		call objetos_mapa_reubicar_objeto_pantalla_actual
	pop af
	ret



eliminar_objeto_del_mapa:
	push af
		call objetos_mapa_eliminar_objeto_pantalla_actual
	pop af
	ret



