;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


FRAMES_ENTRE_CAMBIOS equ 15 



.num_objeto_cambiante:
	db 0


.fire_contador_frames
	db 0



.sfx_objetos:
	db SFX_COGER_LLAVE, SFX_COGER_LLAVE, SFX_COGER_LLAVE, SFX_COGER_LLAVE
	db SFX_COGER_OBJETO 
	db SFX_COGER_OBJETO 
	db SFX_COGER_OBJETO 
	db SFX_COGER_OBJETO 
	db SFX_COGER_OBJETO 
	db 0,0 
	db SFX_COGER_OBJETO 
	db SFX_COGER_OBJ_OBJETIVO, SFX_COGER_OBJ_OBJETIVO, SFX_COGER_OBJ_OBJETIVO, SFX_COGER_OBJ_OBJETIVO 
	db SFX_COGER_LLAVE 




incrementar_fire_contador_frames:
	xor a
	ld hl, fire_contador_frames
	cp (hl)
	ret z    
	dec (hl)
	ret


cambiar_objeto:
accion_fire1:
	call incrementar_fire_contador_frames  
	ret nz

	ld (hl), FRAMES_ENTRE_CAMBIOS

	ld a, (direccion_jugador)
	
	cp DIRECCION_DERECHA
	jr z, _af_der
	cp DIRECCION_IZQUIERDA
	jr z, _af_izq
	cp DIRECCION_ABAJO
	jr z, _af_aba
	
_af_arr
	CalcularCeldaPre -PANTALLA_ANCHO, 0, -1
	jr _af_join
_af_der
	CalcularCeldaPre 1, 1, 0
	jr _af_join
_af_aba
	CalcularCeldaPre PANTALLA_ANCHO, 0, 1
	jr _af_join
_af_izq
	CalcularCeldaPre -1, -1, 0

_af_join
	ld a, (jugador_celda_pre_y)
	bit 7, a
	ret nz
	
	cp PANTALLA_ALTO
	ret z

	ld b, a 
	
	ld a, (jugador_celda_pre_x)
	bit 7, a
	ret nz
	
	ld e, PANTALLA_ANCHO
	cp e
	ret z
	
	ld c, a 
	
	call format44_get_secuencial 
	
	ld ix, objeto_pantalla
	cp (ix + T_OBJETO_PANTALLA_CELDA) 
	ret nz 
	
	ld a, (ix + T_OBJETO_PANTALLA_ID_OBJETO)
let _agua_y_comida_=OBJ_AGUA*256
let _agua_y_comida_=_agua_y_comida_+OBJ_COMIDA
	ld bc, _agua_y_comida_
	cp b
	ret z
	cp c
	ret z

	ld iyl, a   

	ld b, NUM_OBJETOS_MOCHILA
	ld a, (num_objeto_cambiante)
	ld c, a 
	ld d, 0   
	ld e, a   
	ld hl, array_objetos_mochila
	add hl, de   
	ld d, #ff  
	ld e, iyl 
_af_loop
		ld a, (hl) 
		cp e
		jr z, _af_sig
		cp d
		jr nz, _af_cambiar
_af_sig
		call incrementar_objeto_cambiante
_af_djnz
	djnz _af_loop
	RET
	
_af_cambiar
    ld iyh, a  

	
	ld a, iyl
	ld (hl), a

	
	ld a, c
	ld (__posicion_mochila), a

	
	call incrementar_objeto_cambiante  
	ld hl, num_objeto_cambiante
	ld (hl), c

	
	ld a, #00
	__posicion_mochila equ $-1
	call mochila_pintar_objeto 

	ld c, iyl 
	ld b, 0
	ld hl, sfx_objetos
	add hl, bc
	ld l, (hl)
	
	push ix
		call play_sfx
	pop ix

	ld a, iyl
	cp OBJ_PELOTA
	call z, mostrar_mensaje_pelota_si_necesario

	ld a, iyh
	call objeto_cargar_dos

	ld a, iyh
	ld (ix + T_OBJETO_PANTALLA_ID_OBJETO), a
	
	
	ld a, (pantalla_mapa_yx)
	ArraySearch array_objetos_mapa, MAX_OBJETOS_MAPA, TAM_OBJETO_MAPA
	inc hl
	inc hl
	ld a, iyh
	ld (hl), a

	SetCarryFlag 1
	RET
_cambiar_objeto_exit_0
	SetCarryFlag 0
	RET




incrementar_objeto_cambiante:
	inc hl
	inc c
	ld a, c
	cp NUM_OBJETOS_MOCHILA
	ret nz

	ld c, 0
	ld hl, array_objetos_mochila
	ret

