;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


cambiar_pantalla:
	xor a
	ld (num_objeto_cambiante), a

	call celda_mar_reset
	call get_pantalla
	
	if HACER_CELDA_PISABLE_CAMBIO_PANTALLA=1
		ld a, (pantalla_ambiente)
		cp AMB_BOSQUE
		call z, hacer_celda_pisable
	endif
	
	if MUSICA_AMBIENTES=1
		call cambio_musica_entre_pantallas 
	endif
	
	call canibalia_set_ambiente

	call random
	ld (random_enemigo), a

	call pantalla_modificar 
    call objeto_pantalla_actualizar 

	call canibal_reset
	call serpiente_reset

	ResetCeldasAfectadas celdas_afectadas_jugador
	ld a, (jugador_celda_num)        
	ld iy, celdas_afectadas_jugador  
	call ca_calcular_vertical_simple 
	CalcularCoordenadasJugador

	call anadir_canibal 
	call pantalla_poner_canibal_particular
	call anadir_serpiente 

	call check_hay_canibal
	jr nz, _no_canibal1
		ResetAnimacionCanibal
		ResetCeldasAfectadas celdas_afectadas_enemigo
		ld a, (enemigo_celda_num)
		ld iy, celdas_afectadas_enemigo
		call ca_calcular_vertical_simple
		CalcularCoordenadasCanibal
_no_canibal1

	call check_hay_serpiente
	jr nz, _no_serpiente
		ResetCeldasAfectadas celdas_afectadas_enemigo
		ld a, (enemigo_celda_num)
		ld iy, celdas_afectadas_enemigo
		call ca_calcular_vertical_serpiente
		CalcularCoordenadasSerpiente
_no_serpiente
	
	
	if MUSICA_AMBIENTES
		call transiccion_prepare_fade_out
	endif
	
	call #0000
	__cb_borrar_pantalla_efecto equ $-2

	call cambiar_tintas_ambientes
	call objeto_pantalla_render_si_necesario
	call objeto_pantalla_rencer_celdas_afectadas_delante_si_necesario

	call personajes_render_personajes
	call personajes_render_celdas_afectadas_delante


	
_cb_presentar
	call #0000
	__cb_presentar_pantalla_efecto equ $-2

	if MUSICA_AMBIENTES=1
		call transiccion_change_music
		ld a, 0
		call cpct_akp_setFadeVolume_asm
	endif
	
	xor a
	ld (efectos), a

	RET





if MUSICA_AMBIENTES


cambio_musica_entre_pantallas:
	ld a, (pantalla_ambiente)
	add a
	ld c, a  
	ld b, 0  
	
	ld hl, musicas_ambientes
	add hl, bc  
	ldw_indi bc  
	ld de, (nueva_musica)  
	
	call comparar_bc_de
	jr z, _cmep_no_cambio
	
	ld (nueva_musica), bc  
	ld a, 1
	ld (efectos), a
	RET
	
_cmep_no_cambio
	call transicion_reset
	RET

endif






_acc_celda_puerta:
	ld a, (direccion_jugador)
	cp DIRECCION_ARRIBA
	jr z, _acc_celda_test_llave
		scf
		ret
_acc_celda_test_llave
	
	ld a, (ix + CELDA_DATO) 
	ld iyl, a
	push ix
		call mochila_remove_objeto 
	pop ix
	jr z, _acc_celda_puerta_entrar
		
		ld l, SFX_PUERTA_CERRADA
		
			call play_sfx
		
		scf
		ret
_acc_celda_puerta_entrar
	push ix
		ld l, SFX_USAR_LLAVE
		call play_sfx
		ld a, iyl
		call visitar_cabana 
	pop ix
	ld hl, celdas_puertas
	ld c, (ix + CELDA_DATO) 
	jr cambiar_pantalla_por_teletransporte




_acc_celda_teletransporte:
	ld c, (ix + CELDA_DATO)
	ld hl, celdas_teletransporte
	



cambiar_pantalla_por_teletransporte:
	rlc c
	ld b, 0      
	add hl, bc


cambiar_pantalla_por_teletransporte_directo:
	ld a, (hl)  
	ld (pantalla_mapa_yx), a
	call format44_split_byte 
	ld (coordenadas_pantalla), de     

	inc hl
	ld a, (hl)  
	call format44_split_byte 
	ld (jugador_celda), de 
	call update_jugador_celda_num

	call obtener_datos_cambio_pantalla
	call establecer_efectos_pantalla
	call cambiar_pantalla

	SetCarryFlag 1
	ret




cambiar_tintas_ambientes:
	ld c, 11 
	ld a, (pantalla_ambiente)
	cp AMB_CUEVA
	jr z, _cta_cueva
		ld a, sw_9
		jr _cta_comun
_cta_cueva
		ld a, sw_10
_cta_comun
	call set_ink
	ret




if HACER_CELDA_PISABLE_CAMBIO_PANTALLA=1

hacer_celda_pisable:
	ld a, (pantalla_ambiente)
	cp AMB_BOSQUE
	ret nz
	
	ld h, PANTALLA_BYTEH
	ld a, (jugador_celda_num)
	ld l, a
	ld a, (hl)
	
	cp #28  
	jr z, _hcp_navegable
	cp #2b  
	ret z
	
	cp #1f 
	ret z
	cp #1e 
	ret z
	
	
	ld (hl), 0 
	ret
_hcp_navegable
	ld (hl), CELDA_TABLA
	ret

endif

