;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


macro ld_a _valor
	if _valor=0
		xor a
	else
		ld a, _valor
	endif
endm


macro ldb_rr dst, src
	ld a, src
	ld dst, a
mend



macro ldb_mm dst, src
	ld a, (src)
	ld (dst), a
mend


macro ldb_mr dir, reg
	if "reg"="a"
		ld (dir), a
	else
		ld a, reg
		ld (dir), a
	endif
mend



macro ldb_rm reg, dir
	if "reg"="a"
		ld a, (dir)
	else
		ld a, (dir)
		ld reg, a
	endif
mend



macro ldb_mv _direccion, _valor
	if "_valor"="0"
		xor a
	else
		ld a, _valor
	endif
	ld (_direccion), a
mend


macro ldw_mv _direccion, _valor, _registro
	ld _registro, _valor
	ld (_direccion), _registro
endm



macro ldw_rr dst, src
	if "dst"="bc"
		if "src"="de"
			ld b, d
			ld c, e
		elseif "src"="hl"
			ld b, h
			ld c, l
		elseif "src"="ix"
			ld b, ixh
			ld c, ixl
		elseif "src"="iy"
			ld b, iyh
			ld c, iyl
		endif
	elseif "dst"="de"
		if "src"="bc"
			ld d, b
			ld e, c
		elseif "src"="hl"
			ld d, h
			ld e, l
		elseif "src"="ix"
			ld d, ixh
			ld e, ixl
		elseif "src"="iy"
			ld d, iyh
			ld e, iyl
		endif
	elseif "dst"="hl"
		if "src"="de"
			ld h, d
			ld l, e
		elseif "src"="bc"
			ld h, b
			ld l, c
		endif
	elseif "dst"="ix"
		if "src"="de"
			ld ixh, d
			ld ixl, e
		elseif "src"="bc"
			ld ixh, b
			ld ixl, c
		endif
	elseif "dst"="iy"
		if "src"="de"
			ld iyh, d
			ld iyl, e
		elseif "src"="hl"
			ld iyh, h
			ld iyl, l
		elseif "src"="bc"
			ld iyh, b
			ld iyl, c
		endif
	endif
mend



macro ldw_rnn REG16, BYTEH, BYTEL
	if "REG16" = "bc"
		ld b, BYTEH
		ld c, BYTEL
	elseif "REG16" = "de"
		ld d, BYTEH
		ld e, BYTEL
	elseif "REG16" = "hl"
		ld h, BYTEH
		ld l, BYTEL
	elseif "REG16" = "ix"
		ld ixh, BYTEH
		ld ixl, BYTEL
	elseif "REG16" = "iy"
		ld iyh, BYTEH
		ld iyl, BYTEL
	endif
mend




macro ldw_ri REG_DST, REG_PTR, DESP
	if "REG_DST" = "bc"
		ld b, (REG_PTR + DESP + 1)
		ld c, (REG_PTR + DESP)
	elseif "REG_DST" = "de"
		ld d, (REG_PTR + DESP + 1)
		ld e, (REG_PTR + DESP)
	elseif "REG_DST" = "hl"
		ld h, (REG_PTR + DESP + 1)
		ld l, (REG_PTR + DESP)
	endif
mend



macro ldw_ir REG_PTR, DESP, REG_SRC
	if "REG_SRC" = "bc"
		ld (REG_PTR + DESP + 1), b
		ld (REG_PTR + DESP), c
	elseif "REG_SRC" = "de"
		ld (REG_PTR + DESP + 1), d
		ld (REG_PTR + DESP), e
	elseif "REG_SRC" = "hl"
		ld (REG_PTR + DESP + 1), h
		ld (REG_PTR + DESP), l
	endif
mend



macro ldw_indi REG_DEST
	if "REG_DEST" = "bc"
		ld c, (hl)
		inc hl
		ld b, (hl)
		;dec hl
	elseif "REG_DEST" = "de"
		ld e, (hl)
		inc hl
		ld d, (hl)
		;dec hl
	endif
mend


macro ldw_indi_r reg_src
	if "reg_src" = "bc"
		ld (hl), c
		inc hl
		ld (hl), b
	elseif "reg_src" = "de"
		ld (hl), e
		inc hl
		ld (hl), d
	endif		
mend


macro inc_w_indi reg16
	if "reg16"="bc"
		ld b,(hl)
		inc hl
		ld c,(hl)
		inc bc
		ld (hl),c
		dec hl
		ld (hl),d
	endif "reg16"="de"
		ld d,(hl)
		inc hl
		ld e,(hl)
		inc de
		ld (hl),e
		dec hl
		ld (hl),d
	endif
endm
	


macro dec_w_indi reg16
	if "reg16"="bc"
		ld b,(hl)
		inc hl
		ld c,(hl)
		dec bc
		ld (hl),c
		dec hl
		ld (hl),d
	endif "reg16"="de"
		ld d,(hl)
		inc hl
		ld e,(hl)
		dec de
		ld (hl),e
		dec hl
		ld (hl),d
	endif
endm
	


macro add_de_bc
	ex de, hl
	add hl, bc
	ex de, hl
endm



macro inc_m direccion
	ld hl, direccion
	inc (hl)
endm


macro dec_m direccion
	ld hl, direccion
	dec (hl)
endm



macro dec_w_m direccion, reg16
	ld reg16, (direccion)
	dec reg16
	ld (direccion), reg16
endm


macro __test_rr_es_0 r1, r2
	ld a, r1
	or r2
endm


macro test_rr_0 reg16
	if "reg16"="bc"
		__test_rr_es_0 b, c
	elseif "reg16"="de"
		__test_rr_es_0 d, e
	elseif "reg16"="hl"
		__test_rr_es_0 h, l
	endif
endm
