;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

K_CursorUp	equ	#0100 
K_CursorRight	equ	#0200 
K_CursorDown	equ	#0400 
K_F9		equ	#0800
K_F6		equ	#1000  
K_F3		equ	#2000  
K_Enter		equ	#4000 
K_Fdot		equ	#8000 

K_CursorLeft	equ	#0101 
K_Copy		equ	#0201  
K_F7		equ	#0401 
K_F8		equ	#0801 
K_F5		equ	#1001 
K_F1		equ	#2001 
K_F2		equ	#4001 
K_F0		equ	#8001 

K_CLR			equ	#0102 
K_CorcheteOpen	equ	#0202
K_Return		equ	#0402
K_CorcheteClose	equ	#0802
K_F4		equ	#1002
K_Shift		equ	#2002
K_BackSlash	equ	#4002
K_Control	equ	#8002

K_Gorrillo	equ	#0103
K_Guion		equ	#0203
K_Arroba	equ	#0403
K_P			equ	#0803
K_PuntoComa	equ	#1003
K_DosPuntos	equ	#2003
K_Slash		equ	#4003
K_Punto		equ	#8003

K_0	equ	#0104
K_9	equ	#0204
K_O	equ	#0404
K_I	equ	#0804
K_L	equ	#1004
K_K	equ	#2004
K_M	equ	#4004
K_Coma	equ	#8004

K_8	equ	#0105
K_7	equ	#0205
K_U	equ	#0405
K_Y	equ	#0805
K_H	equ	#1005
K_J	equ	#2005
K_N	equ	#4005
K_Space	equ	#8005

K_6	equ	#0106
K_5	equ	#0206
K_R	equ	#0406
K_T	equ	#0806
K_G	equ	#1006
K_F	equ	#2006
K_B	equ	#4006
K_V	equ	#8006

K_4	equ	#0107
K_3	equ	#0207
K_E	equ	#0407
K_W	equ	#0807
K_S	equ	#1007
K_D	equ	#2007
K_C	equ	#4007
K_X	equ	#8007

K_1	equ	#0108
K_2	equ	#0208
K_Esc	equ	#0408
K_Q	equ	#0808
K_Tab	equ	#1008
K_A	equ	#2008
K_Mays	equ	#4008
K_Z	equ	#8008

K_Joy1Up	equ	#0109
K_Joy1Down	equ	#0209
K_Joy1Left	equ	#0409
K_Joy1Right	equ	#0809
K_Joy1Fire1	equ	#1009
K_Joy1Fire2	equ	#2009
K_Joy1Fire3	equ	#4009
K_Del		equ	#8009




PANTALLA_1 equ #8000
PANTALLA_2 equ #C000




macro add_backbuffer_to reg8
	ld a, (backbuffer)
	add reg8
	ld reg8, a
endm



macro add_videopage_to reg8
	ld a, (backbuffer)
	xor #40
	add reg8
	ld reg8, a	
endm




SPR_SPRITE_PERSONAJE_ANCHO  equ 6
SPR_SPRITE_PERSONAJE_ALTO   equ 27
SPR_ALTO_CABEZA equ 15
SPR_ALTO_PIES   equ 12

TAM_SPRITE_PERSONAJE  equ  SPR_SPRITE_PERSONAJE_ANCHO*SPR_SPRITE_PERSONAJE_ALTO
TAM_SPRITE_CABEZA     equ  SPR_SPRITE_PERSONAJE_ANCHO*SPR_ALTO_CABEZA
TAM_SPRITE_PIES       equ  SPR_SPRITE_PERSONAJE_ANCHO*SPR_ALTO_PIES

OFFSET_REPOSO equ 0

OFFSET_PIE_IZQ equ TAM_SPRITE_PIES
OFFSET_PIE_DER equ TAM_SPRITE_PIES+TAM_SPRITE_PIES
OFFSET_CABEZA  equ TAM_SPRITE_PIES+TAM_SPRITE_PIES+TAM_SPRITE_PIES


COORDENADA_Y_INICIO_PARA_PERSONAJE equ 5*8-6 


macro RenderMarco dir_marco, ancho_marco, alto_marco, color
	sprite_SetParametrosRectangulo color, ancho_marco, alto_marco
	ld hl, dir_marco
	call sprite_render_rectangulo
endm



macro RenderTextoConColor dir_texto, largo_texto, dir_despl_posicion, dir_colores_nuevos
	ld hl, dir_texto
	ld de, dir_despl_posicion
	add_videopage_to d
	push de
		call pintar_texto
	pop hl 

	ld d, largo_texto
	ld ix, array_bytes_colores_caracteres
	ld iy, dir_colores_nuevos
	
endm



macro RenderTexto dir_texto, dir_mem
	ld hl, dir_texto
	ld de, dir_mem
	call pintar_texto
endm


macro RenderTextoBackbuffer dir_texto, dir_mem
	ld hl, dir_texto
	ld de, dir_mem
	add_backbuffer_to d
	call pintar_texto
endm



macro PresentarPantalla efecto
	call presentar_pantalla_{efecto}
endm




macro new_ObjetoPantalla
	BeginStruct T_OBJETO_PANTALLA
		let fill_byte=#ff
		FieldStruct T_OBJETO_PANTALLA, ID_OBJETO, 1
		FieldStruct T_OBJETO_PANTALLA, CELDA, 1
		FieldStruct T_OBJETO_PANTALLA, OFFSET, 2
		let fill_byte=#00
	EndStruct T_OBJETO_PANTALLA
endm





SPRITE_MINI_OBJETO_ALTO  equ 14
SPRITE_MINI_OBJETO_ANCHO equ 4
TAM_SPRITE_MINI_OBJETO   equ SPRITE_MINI_OBJETO_ANCHO*SPRITE_MINI_OBJETO_ALTO


SPRITE_GRAN_OBJETO_ALTO  equ 16
SPRITE_GRAN_OBJETO_ANCHO equ 6
TAM_SPRITE_GRAN_OBJETO   equ SPRITE_GRAN_OBJETO_ANCHO*SPRITE_GRAN_OBJETO_ALTO
TAM_MITAD_SPRITE_GRAN_OBJETO   equ TAM_SPRITE_GRAN_OBJETO/2




BAJON_PICADURA_NIVEL_AGUA    equ 8
BAJON_PICADURA_NIVEL_ENERGIA equ 8




macro VentanaJuego _ventana
	ld hl, _ventana
	call ventana_juego
endm



PERSONAJE_CELDA_REFERENCIA equ 6
PERSONAJE_FUNC_CALCULAR_CA equ 7
PERSONAJE_CELDAS_AFECTADAS equ 9

ID_CELDA_NATIVA equ #4D





macro SetParametrosCopiarTrozoPantalla _ancho, _bloques_lineas
	ld a, _ancho
	ld (__rcb_ancho), a
	ld bc, #800-_ancho
	ld (__rcb_800_ancho), bc
	ld a, _bloques_lineas
	ld (__rcb_bloques_alto), a
endm


macro SetParametrosPintarRectangulo _ancho, _bloques_lineas
	ld a, _ancho-1
	ld (__borr_rect_ancho), a
	ld bc, #800-_ancho+1
	ld (__borr_rect_800_ancho), bc
	ld a, _bloques_lineas
	ld (__borr_rect_alto), a
endm
	
	
macro SetParametrosPintarRectanguloAncho _ancho
	ld a, _ancho-1
	ld (__borr_rect_ancho), a
	ld bc, #800-_ancho+1
	ld (__borr_rect_800_ancho), bc
endm





CELDA_TIPO_OBSTACULO       equ %00000000
CELDA_TIPO_PISABLE         equ %10000000
CELDA_TIPO_CORT_HOZ        equ %01000000
CELDA_TIPO_CORT_SIERRA     equ %00100000
CELDA_TIPO_RIO             equ %00010000
CELDA_TIPO_TELETRANSPORTE  equ %00001000 
CELDA_TIPO_PUERTA          equ %00000100 
CELDA_TIPO_FUNCION         equ %00000010



CELDA_BIT_PISABLE          equ 7
CELDA_BIT_CORTABLE_HOZ     equ 6
CELDA_BIT_CORTABLE_SIERRA  equ 5
CELDA_BIT_NAVEGABLE        equ 4
CELDA_BIT_TELETRANSPORTE   equ 3 
CELDA_BIT_PUERTA           equ 2
CELDA_BIT_FUNCION          equ 1



BeginStruct CELDA
	DeclareFieldStruct  CELDA, ID, 1
	DeclareFieldStruct  CELDA, FLAGS, 1
	DeclareFieldStruct  CELDA, ALTURA, 1
	DeclareFieldStruct  CELDA, DATO, 1
	DeclareFieldStruct  CELDA, SPRITE1, 2
	DeclareFieldStruct  CELDA, SPRITE2, 2
	DeclareFieldStruct  CELDA, SPRITE3, 2
	DeclareFieldStruct  CELDA, SPRITE4, 2
	DeclareFieldStruct  CELDA, SPRITE5, 2
EndStruct CELDA



macro CrearCelda _id, _flags, _altura, _dato_extra, _sprite1, _sprite2, _sprite3, _sprite4, _sprite5
	db _id
	db _flags
	db _altura 
	db _dato_extra
	dw _sprite1
	dw _sprite2
	dw _sprite3
	dw _sprite4
	dw _sprite5
endm




TAM_ARRAY_TECLAS_JUEGO equ 6


macro CalcularCeldaPre sumar, inc_x, inc_y
	ld d, inc_y
	ld e, inc_x
	ld b, sumar
	call calcular_celda_pre
endm



	

macro aWriteCRTC registro, valor
	ld bc, #bc00 + registro
	out (c), c
	ld bc, #bd00 + valor
	out (c), c
endm


macro WriteCRTC registro, valor
	ld hl, registro*256 + valor
	call set_crtc
endm



macro SetAnchoPantalla ancho
	WriteCRTC 1, ancho
endm


macro SetAltoPantalla alto
	WriteCRTC 6, alto
endm


macro SetPosicionHorizontal n
	WriteCRTC 2, 50-n
endm


macro SetPosicionVertical n
	WriteCRTC 7, 35-n
endm




macro new_COORDENADA
	BeginStruct COORDENADA
		FieldStruct COORDENADA, X, 1
		FieldStruct COORDENADA, Y, 1
	EndStruct COORDENADA
endm





macro listabytes_reset dir_lista, tam_lista, valor_relleno
	ld hl, dir_lista
	ld de, dir_lista+1
	ld bc, tam_lista-1
	ld (hl), valor_relleno
	ldir
endm




macro listabytes_add_byte dir_lista, tam_lista, byte_hueco
    ld hl, dir_lista
    ld bc, tam_lista
    ld a, byte_hueco
    call listabytes_buscar_a_escribir_d
endm



macro listabytes_del_byte dir_lista, tam_lista, byte_hueco
    ld hl, dir_lista
    ld bc, tam_lista
    ld d, byte_hueco
    call listabytes_buscar_a_escribir_d
endm




macro listabytes_isin dir_lista, tam_lista
	ld bc, tam_lista
	ld hl, dir_lista
	cpir
endm


macro listabytes_find dir_lista, tam_lista
	ld bc, tam_lista
	ld hl, dir_lista
	cpir
endm




INCR_ANIM_ARRIBA     equ  #FE00
INCR_ANIM_ABAJO      equ  #0200
INCR_ANIM_IZQUIERDA  equ  #00FE
INCR_ANIM_DERECHA    equ  #0002



PASOS_HORIZONTAL equ 6
PASOS_VERTICAL   equ 8

MAX_SUB_NFRAMES  equ 3



macro new_ANIMACION  _array_sprites
	BeginStruct ANIMACION
		DeclareFieldStruct  ANIMACION, INCREMENTOS, 2   
		dw #0000
		DeclareFieldStruct  ANIMACION, PASOS, 1      
		db #00
		DeclareFieldStruct  ANIMACION, DIRECCION, 1   
		db 1
		DeclareFieldStruct  ANIMACION, NFRAME, 1
		db 0
		DeclareFieldStruct  ANIMACION, SUBNFRAME, 1
		db 0
		DeclareFieldStruct  ANIMACION, ARRAY_SPRITES, 2
		dw _array_sprites
	EndStruct ANIMACION
endm






macro CrearAnimacionPersonaje _animacion, _incrementos, _pasos, _direccion
	ld ix, _animacion
	ld bc, _incrementos
	ldw_ir ix, ANIMACION_INCREMENTOS, bc
	ld (ix + ANIMACION_PASOS), _pasos
	
endm




macro AnimarJugador
	ld ix, coordenadas_jugador
	ld iy, animacion_jugador
	call animacion_actualizar
endm



macro AnimarCanibal
	ld ix, coordenadas_enemigo
	ld iy, animacion_enemigo
	call animacion_actualizar
endm



macro ResetAnimacionJugador
	ld iy, animacion_jugador
	call animacion_reset
endm


macro ResetAnimacionCanibal
	ld iy, animacion_enemigo
	call animacion_reset
endm




macro new_RELOJ
	BeginStruct RELOJ
		FieldStruct RELOJ, TICKS, 1
		FieldStruct RELOJ, SEGUNDOS_TOTALES, 2
		FieldStruct RELOJ, SEGUNDOS, 1
		FieldStruct RELOJ, MINUTOS, 1
		
	EndStruct RELOJ
endm



NUM_TICKS_SEGUNDO equ 50   





MAX_CELDAS_MODIFICADAS equ 58 

TIPO_INVALIDA equ #ff



macro new_CeldaModificada
	BeginStruct CELDA_MODIFICADA
		FieldStruct CELDA_MODIFICADA, PANTALLA, 1
		FieldStruct CELDA_MODIFICADA, NUM_CELDA, 1
		FieldStruct CELDA_MODIFICADA, TIPO_CELDA, 1
	EndStruct CELDA_MODIFICADA
endm



macro ArraySearch dir_array, num_elementos, tam_elemento
    ld hl, dir_array
    ld b, num_elementos
    ld de, tam_elemento
    call array_search_item
endm




macro ArrayReset dir_array, num_elementos, tam_elemento, valor_relleno
    ld hl, dir_array
    ld de, tam_elemento
    ld b, num_elementos
    ld a, valor_relleno
    call array_reset
endm






macro GetArrayItem dir_array, num_item, tam_item, reg_dst
	ld hl, dir_array
	ld de, tam_item
	ld a, num_item
	call get_array_item
	ldw_indi reg_dst
endm




macro GetWordShortArrayItem dir_array, num_item, reg_dst
	ld hl, dir_array
	ld a, num_item
	call get_word_array
	ldw_indi reg_dst
endm




macro GetWordArrayItem dir_array, num_item, reg_dst
	ld hl, dir_array
	ld bc, num_item
	call get_word_array2
	ldw_indi reg_dst
endm




macro GetWordShortMatrixItem dir_array, fila, columna, ancho, reg_dst
	ld hl, dir_array
	ld bc, ancho*2
	ld d, fila
	ld e, columna
	call get_word_matriz
	ldw_indi reg_dst
endm





macro GetByteMatrixItem dir_array, fila, columna, ancho
	ld hl, dir_array
	ld bc, ancho
	ld d, fila
	ld e, columna
	call get_byte_matriz
endm




macro GetByteArrayItem dir_array, num_item
	ld hl, dir_array
	ld a, num_item
	call get_array_bytes_item
endm

	

macro FillArray dir_inicio, num_bytes, valor_relleno
	ld hl, dir_inicio
	ld de, dir_inicio+1
	ld bc, num_bytes-1
	ld (hl), valor_relleno
	ldir
endm
	



macro ArrayGetItem _dir_array, _tam_elemento
	ld hl, _dir_array
	ld de, _tam_elemento
	call array_get_item
endm





macro RandomMax _maxValue
	ld e, _maxValue
	call random_max_e 
endm



macro RandomMinMax _minValue, _maxValue
	ld e, _maxValue-_minValue
	call random_max_e

	if "_minValue"="1"
		inc a
	else
		add a, _minValue
	endif
endm







GA_port        equ #7F00  
GA_port_byte   equ #7F    
PAL_PENR       equ #00    
PAL_INKR       equ #40    
PPI_PORT_B     equ #F5    
CRTC_SELECTREG equ #BC    
CRTC_SETVAL    equ #BD    





macro SetPaletaColores array_colores
	ld hl, array_colores
	call set_palette
endm





let INC_MAPA_Y=256*PANTALLA_ALTO
let INC_MAPA_Y=INC_MAPA_Y-256

INC_MAPA_Y_X_ARRIBA equ -INC_MAPA_Y
INC_MAPA_Y_X_ABAJO equ   INC_MAPA_Y
INC_MAPA_Y_X_IZQUIERDA equ -PANTALLA_ANCHO+1
INC_MAPA_Y_X_DERECHA equ PANTALLA_ANCHO-1



let NUM_TECLAS_ESCANEAR = 0

macro new_TECLA _id_tecla, _mascara_tecla, _funcion
	BeginStruct TECLA
		.{_id_tecla}:
		dw _mascara_tecla
		DeclareFieldStruct TECLA, CODIGO, 2
		dw _funcion
		DeclareFieldStruct TECLA, FUNCION, 2
	EndStruct TECLA
	let NUM_TECLAS_ESCANEAR=NUM_TECLAS_ESCANEAR+1
endm




macro new_DatosMovimiento incrementos_anim, _pasos_anim, celda_ref_ccaa, func_calcular_ccaa
	BeginStruct DATOS_MOV
		dw incrementos_anim
		db _pasos_anim
		db celda_ref_ccaa 
		dw func_calcular_ccaa
		DeclareFieldStruct DATOS_MOV, INCR_ANIM, 2
		DeclareFieldStruct DATOS_MOV, PASOS_ANIM, 1
		DeclareFieldStruct DATOS_MOV, CELDA_REF, 1
		DeclareFieldStruct DATOS_MOV, FN_CALCULAR_CCAA, 2
	EndStruct DATOS_MOV
endm




DISTINTIVO_CELDA     equ %10000000
REQ_HUECO_MOCHILA_SI equ %01000000
REQ_HUECO_MOCHILA_NO equ %00000000

let cont_def_obj_acc=0
macro new_DefObjetoAcciones id_objeto, requisito_hueco_mochila, funciones, num_sonido
	let cont_def_obj_acc=cont_def_obj_acc+1
    BeginStruct T_OBJETO_ACCION
        db id_objeto + requisito_hueco_mochila + DISTINTIVO_CELDA 
        db funciones + num_sonido
        DeclareFieldStruct  T_OBJETO_ACCION, IDS, 1
        DeclareFieldStruct  T_OBJETO_ACCION, ACCIONES, 1
    EndStruct T_OBJETO_ACCION
endm



FUN_ANADIR          equ %10000000  
BIT_ANADIR_MOCHILA  equ 7
FUN_CONSUMIR        equ %01000000  
BIT_CONSUMIR_OBJ    equ 6
FUN_ELIMINAR        equ %00100000
BIT_ELIMINAR        equ 5
FUN_REUBICAR        equ %00010000
BIT_REUBICAR        equ 4
MASK_SONIDO         equ %00001111  






macro Menu_DrawImage dir_imagen_zx0, ancho_imagen, alto_imagen, posicion_imagen
	ld hl, dir_imagen_zx0
	ld de, FIN
	call dzx0

	ld iyh, alto_imagen
	ld hl, FIN
	ld de, posicion_imagen
	ldw_mv __spr_r_800_ancho, #800-ancho_imagen, bc
	ldw_mv __spr_r_ancho, ancho_imagen, bc
	call sprite_render 
endm




macro InstallMusic _dir_music
	ld hl, _dir_music
	ld de, musica
	call dzx0
endm


macro PlayFX _num_fx
	
		ld l, _num_fx
		call play_sfx
	
endm




macro ld_backbuffer_to reg16
	ld a, (backbuffer)
	if "reg16"="de"
		ld d, a
		ld e, 0
	elseif "reg16"="bc"
		ld b, a
		ld c, 0
	elseif "reg16"="hl"
		ld h, a
		ld l, 0
	endif
endm





macro sprite_SetAnchoSprite ancho
	ldw_mv __spr_r_800_ancho, #800-ancho, bc
	ldw_mv __spr_r_ancho, ancho, bc
endm




macro add_to_DE cte
	push bc
		ex de, hl
		ld bc, cte
		add hl, bc
		ex de, hl
	pop bc	
endm



macro add_to_BC cte
	push hl
		ldw_rr hl, bc
		ld bc, cte
		add hl, bc
		ldw_rr bc, hl
	pop hl
endm





ANCHO_LOGO equ 43
ALTO_LOGO equ 30

ANCHO_IMG equ 42
ALTO_IMG equ 50

SW equ SCREEN_WIDTH


POSICION_LOGO equ #c000 + 15

POSICION_IMG_BLOQUE equ SCREEN_WIDTH*14
POSICION_IMG_LINEAS equ #800 * 1
POSICION_IMG equ #c000 + POSICION_IMG_BLOQUE + POSICION_IMG_LINEAS + 15

MENU_LINEA_1 equ SW + SW + SW + SW + SW + SW
MENU_LINEA_2 equ SW + SW + SW + SW + SW + SW + SW + SW
MENU_LINEA_3 equ SW + SW + SW + SW + SW + SW + SW + SW + SW + SW

POSICION_MENU_OPC1 equ #c000 + MENU_LINEA_1 + 25 
POSICION_MENU_OPC2 equ #c000 + MENU_LINEA_2 + 25
POSICION_MENU_OPC3 equ #c000 + MENU_LINEA_3 + 25


POSICION_PRESS_KEY equ #c000 + #1b0 + #16  
POSICION_KEY       equ #c000 + #288 + #20 


NUM_TECLAS_REDEFINIDAS equ 5


TAM_ARRAY_TECLAS_MENU equ 3
