;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

MAX_ORDENES equ 8


ORDEN_ACTUALIZAR_MOCHILA  equ 0
ORDEN_ACTUALIZAR_AGUA     equ 1
ORDEN_ACTUALIZAR_ENERGIA  equ 2
ORDEN_ACTUALIZAR_TIEMPO   equ 3




.marcador_actualizar:
	db 0

.marcador_tam_cola_ordenes:
	db 0


.marcador_ordenes:
	ds MAX_ORDENES

.marcador_ordenes_mochila:
	ds MAX_ORDENES
	ds MAX_ORDENES



marcador_reset:
	ld hl, marcador_tam_cola_ordenes
	ld (hl), 0
	
	ld hl, marcador_actualizar
	ld (hl), 2
	
	ret




marcador_render_update:
	ld a, (marcador_tam_cola_ordenes)
	or a 
	ret z   

	ld a, (marcador_actualizar)
	cp 1
	jr z, _mru_procesar

	ld a, (sprites_descomprimidos)
	or a 
	ret nz
_mru_procesar
	call marcador_procesar_orden

	ld hl, marcador_actualizar
	dec (hl)
	ret nz
	
	ld (hl), 2
	call marcador_avanzar_cola

	RET




marcador_avanzar_cola:
	ld hl, marcador_tam_cola_ordenes
	dec (hl)

	ld hl, marcador_ordenes+1
	ld de, marcador_ordenes
	ld bc, MAX_ORDENES-1
	ldir

	ld hl, marcador_ordenes_mochila+2
	ld de, marcador_ordenes_mochila
	ld bc, MAX_ORDENES+MAX_ORDENES-2
	ldir

	RET




marcador_anadir_orden:
	ld a, (marcador_tam_cola_ordenes)
	ld c, a
	ld b, 0    

	ld a, d 
	cp ORDEN_ACTUALIZAR_MOCHILA
	call z, marcador_anadir_orden_mochila

	ld hl, marcador_ordenes
	add hl, bc
	ld (hl), d 

	ld hl, marcador_tam_cola_ordenes
	inc (hl)


	RET




marcador_anadir_orden_mochila
	rlc c
		ld hl, marcador_ordenes_mochila
		add hl, bc
		ld a, ixh
		ld (hl), a    
		inc hl
		ld a, ixl
		ld (hl), a    
	rrc c

	ret



.funciones_render_update:
	dw marcador_procesar_orden_mochila
	dw vida_render_agua
	dw vida_render_energia
	dw render_reloj_pre




marcador_procesar_orden:
	ld a, (marcador_ordenes)
	ld c, a
	rlc c
	ld b, 0
	ld hl, funciones_render_update
	add hl, bc
	
	ld a, (hl)
	inc hl
	ld h, (hl)
	ld l, a
	
	jp (hl)
	
	
	

marcador_procesar_orden_mochila:
	ld hl, marcador_ordenes_mochila
	ld a, (hl)  
	ld (render_objeto_posicion), a
	inc hl
	ld a, (hl)  
	ld (render_objeto_tipo), a
	call mochila_render_update
	ret


