;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


__INICIO_MENU_COMPRIMIBLE__


.menu_opc1:
	db "1< Joystick",0
.menu_opc2:
	db "2< Keyboard",0
.menu_opc3:
	db "3< Redefine",0
	
.menu_press_key
	db "Press a key to",0
	
.txt_redefine_up
	db " UP",0
.txt_redefine_down
	db "DOWN",0
.txt_redefine_left
	db "LEFT",0
.txt_redefine_right
	db "{RIGHT",0
.txt_redefine_use
	db "{^{FIRE^",0

.creditos1:
	  db "Music     Code|_|Gfx    Graphics",0
.creditos2:
	db "Riskwood    |Gallegux    |Javy Fdez",0
	


.array_teclas_menu:
	new_TECLA  tecla_1, K_1, play_with_joystick
	new_TECLA  tecla_2, K_2, play_with_keyboard
	new_TECLA  tecla_3, K_3, redefine_keyboard



.array_nombres_teclas_redefinir
	dw txt_redefine_up, txt_redefine_down, txt_redefine_left, txt_redefine_right, txt_redefine_use


.array_teclas_joystick
	dw K_Joy1Up, K_Joy1Down, K_Joy1Left, K_Joy1Right, K_Joy1Fire1
	


test_teclas_menu:
	call waitVSYNC

	call random
if CELDAS_AZAR=1
	ld (random_partida), a
endif

	di
		call scan_keyboard
	ei

	ld ix, array_teclas_menu
	ld d, TAM_ARRAY_TECLAS_MENU

_eom_loop

	ldw_ri bc, ix, TECLA_CODIGO
	call is_key_pressed 
	jr z, _eom_tecla_no_pulsada
		push ix
		push de
			ldw_ri bc, ix, TECLA_FUNCION
			ld (__eom_call_funcion_tecla), bc
			call #CAFE
			__eom_call_funcion_tecla equ $-2
		pop de
		pop ix
_eom_tecla_no_pulsada
	dec d
	jr z, test_teclas_menu
		ld bc, TAM_TECLA
		add ix, bc
		jr _eom_loop






menu_pintar:
	call check_hay_musica
	jr z, _mp_no_descomprimir
		InstallMusic musica_menu_compressed
_mp_no_descomprimir
	call menu_pintar_graficos
	call text_render_pre
	call menu_pintar_creditos
	call menu_pintar_opciones
	
if ANIMACION_PAJAROS=1
	call descomprimier_sprites_pajaros 
endif
	
	
	SetPaletaColores array_paleta_menu
	ldb_mv modo, MODO_MENU
	
	call waitVSYNC
	halt : halt
	call waitVSYNC

	call check_hay_musica
	ret z
	
	call play_music

	ret 






menu_pintar_graficos:	
	Menu_DrawImage logo_menu_zx0, ANCHO_LOGO, ALTO_LOGO, POSICION_LOGO
	Menu_DrawImage img_menu_zx0,   ANCHO_IMG, ALTO_IMG, POSICION_IMG
	ret



menu_pintar_creditos:
	let fila_creditos1=SCREEN_WIDTH*23      
	let fila_creditos1=fila_creditos1+#3000  
	let fila_creditos1=fila_creditos1+#c000

	let fila_creditos2=SCREEN_WIDTH*24      
	let fila_creditos2=fila_creditos2+#3800  
	let fila_creditos2=fila_creditos2+#c000
	

	ld hl, colores_letras_normales
	ld bc, colores_letras_creditos1
	call cambiar_colores_fuente
	
	RenderTexto creditos1, fila_creditos1+7 
	
	ld hl, colores_letras_creditos1
	ld bc, colores_letras_creditos2
	call cambiar_colores_fuente
	
	RenderTexto creditos2, fila_creditos2+4
	
	ld hl, colores_letras_creditos2
	ld bc, colores_letras_opciones_menu
	call cambiar_colores_fuente
	
	ret
	



menu_pintar_opciones:
	call borrar_rectangulo_menu

	RenderTexto menu_opc1, POSICION_MENU_OPC1
	RenderTexto menu_opc2, POSICION_MENU_OPC2
	RenderTexto menu_opc3, POSICION_MENU_OPC3
	
	ret





borrar_rectangulo_menu:
	ld a, 28
	ld (__borr_rect_ancho), a
	ld bc, #800-28
	ld (__borr_rect_800_ancho), bc
	ld iyh, 5

	ld hl, POSICION_PRESS_KEY
	call ph_borrar_rectangulo_alto
	ret




copiar_array_indi:
	ld a, NUM_TECLAS_REDEFINIDAS
	ld de, tecla_arriba 
	
_cai_loop
	ldi
	ldi
	inc de 
	inc de 
	dec a
	jr nz, _cai_loop
	ret




play_with_joystick:
	ld hl, array_teclas_joystick
	call copiar_array_indi
	jp jugar
	
	


play_with_keyboard:
	ld hl, array_teclas_redefinidas
	call copiar_array_indi
	jp jugar
	



redefine_keyboard:
	call borrar_rectangulo_menu
	
	ld hl, menu_press_key
	ld de, POSICION_PRESS_KEY
	call pintar_texto
	
	ld ix, array_nombres_teclas_redefinir
	ld iy, array_teclas_redefinidas
	ld a, NUM_TECLAS_REDEFINIDAS
	
_rk_loop
	push af
	push ix
	push iy
		Esperar 1
		ldw_ri hl, ix, 0 
		ld de, POSICION_KEY
		
		call pintar_texto
_rk_get_key
		call waitVSYNC
		call scan_keyboard
		call is_any_key_pressed 
		jr z, _rk_get_key
		
		ld de, K_Esc
		call comparar_bc_de 
		jr z, _rk_get_key

		push bc
			PlayFX SFX_TECLA_REDEFINIDA
		pop bc
	pop iy
	pop ix
	pop af

	ldw_ir iy, 0, bc  
	
	ld bc, 2
	add ix, bc
	add iy, bc
	
	dec a
	jr nz, _rk_loop
	
	Esperar 2
	
	call menu_pintar_opciones
	
	ret


	
__FIN_MENU_COMPRIMIBLE__
	