org #1000
run #1000

MAX_MOVIMIENTOS equ 3

PANTALLA_ANCHO equ 12
PANTALLA_ALTO  equ 10
PANTALLA_TAM   equ PANTALLA_ANCHO*PANTALLA_ALTO


DIR_UP equ 0
DIR_DO equ 1
DIR_LE equ 2
DIR_RI equ 3

MOV_UP equ #ff00
MOV_DO equ #0100
MOV_LE equ #ffff
MOV_RI equ #0001

;ld hl, #0505
;ld bc, MOV_UP
;add hl, bc
;
;ld bc, MOV_DO
;add hl, bc
;
;ld bc, MOV_LE
;add hl, bc
;
;ld bc, MOV_RI
;add hl, bc
;
call buscar_ruta



jr $




read "..\libs\macros_comparaciones.asm"
read "..\libs/listabytes.asm"
read "..\libs/formato44.asm"
read "..\libs/arrays.asm"











buscar_ruta:
	ld bc, (enemigo)
	ld e, PANTALLA_ANCHO
	call format44_get_secuencial ; a=numero de celda
	ld (lista_celdas_pisadas), a
	jr _br_ini
_br_loop_grande
	ld a, (num_celdas_pisadas)
	cp MAX_MOVIMIENTOS
	ret z
_br_ini
	ld de, (jugador) 
	ld bc, (enemigo)
	ld a, d
	cp b 
	jr nz, _br_sigue
	ld a, e
	cp c
	ret z

_br_sigue
	ld a, d
	sub b
	ld h, a  ;h=Jx-Ex
	
	ld a, e
	sub c
	ld l, a  ;l=Jy-Ey

	;creamos la clave en a
	xor a ; a=0
	bit 7, h
	jr nz, _br_creando_clave1
		or %00000010 ; =x+ ; x- = 0
_br_creando_clave1
	bit 7, l
	jr nz, _br_creando_clave2
		or %00000001 ; =y+ ; y- = 0
_br_creando_clave2
	ld iyh, a ; iyh=clave

	ld a, h
	sub l
	ld a, iyh  ;conserva el flag, a=clave
	jr c, _br_dy_mayor
	or %10000000
	jr _br_comprobar_direcciones
_br_dy_mayor
	or %01000000
_br_comprobar_direcciones
	;ld iyh, a ;; en iyh guardamos la clave
	ArraySearch prioridades_movimientos, 8, 5
	; 5=tam
	
	ld iyl, 4 ; direcciones
_br_loop
	inc hl ; hl->una direccion
	push hl
		ld a, (hl)
		call evaluar_movimiento_enemigo
	pop hl
	jp nz, almacenar_movimiento_enemigo
	dec iyl
	jr nz, _br_loop

	RET




;; in
;; a - direccion
;; out
;; z - z=1 la direccion no vale ; z=0=si vale
;; bc - nueva celda (y,x)
;; a - direccion
;; iyh - num celda
evaluar_movimiento_enemigo:
	ld (_mov_direccion), a

	ld hl, movimientos
	ld b, 0
	ld c, a
	sla c ; bc=a*2
	add hl, bc ; hl-> movimientos[a]

	ld c, (hl)
	inc hl
	ld b, (hl) ; bc = movimientos[a]

	ld hl, (enemigo)
	add hl, bc ; posible coordenada nueva del enemigo
	
	ld a, -1
	cp h
	ret z
	cp l
	ret z

	ld a, PANTALLA_ALTO
	cp h
	ret z
	ld a, PANTALLA_ANCHO
	cp l
	ret z
	
	ld b, h
	ld c, l
	push bc
		ld e, PANTALLA_ANCHO
		call format44_get_secuencial ; a=numero de celda
	pop bc ; enemigo y x

	ld hl, pantalla
	ld l, a
	xor a
	cp (hl)
	jr nz, _mov_novale
		ld a, l 
		ld iyh, a  ; iyh num celda
		; la celda vale
		or 1 ; z=0
		ld a, #00 ;direccion
		_mov_direccion equ $-1
		ret
_mov_novale
	xor a ; z=1
	ret
	



;; in
;; a - direccion
;; bc - celda (y,x)
;; iyh - num celda
almacenar_movimiento_enemigo:
	ld (enemigo), bc ; posicion nueva del enemigo

	ld hl, num_celdas_pisadas
	ld d, 0
	ld e, (hl)  ; de=num.celdas_pisadas
	inc (hl) ; incrementamos el num.de celdas pisadas, pero trabajamos con el valor anterior

	; almacenar direccion
	ld hl, movimientos_jugador
	add hl, de
	ld (hl), a

	; almacenar la celda pisada
	ld hl, lista_celdas_pisadas+1
	add hl, de
	ld a, iyh
	ld (hl), a
	
	jp _br_loop_grande


org #1170
align 256
pantalla:
	db 1,0,1,1,0,1,1,1,0,1,1,1
	db 1,0,0,0,0,1,1,1,0,1,1,0
	db 1,1,0,1,0,1,0,1,0,0,1,0
	db 0,0,0,0,0,0,0,1,0,0,0,0
	db 1,0,1,1,0,1,0,0,0,1,1,1
	db 1,1,1,0,0,1,1,1,0,1,0,1
	db 0,1,0,0,1,1,0,0,0,0,0,1
	db 0,0,0,0,0,0,0,0,1,0,0,0
	db 1,1,1,0,1,0,1,0,0,0,1,1
	db 0,0,1,0,0,0,0,0,0,0,1,1

jugador:
jugador_x:
	db 9
jugador_y:
	db 1

enemigo:
enemigo_x:
	db 0
enemigo_y:
	db 6

lista_celdas_pisadas:
	repeat MAX_MOVIMIENTOS+1
		db #ff
	rend

num_celdas_pisadas:
	db 0

movimientos_jugador:
	repeat MAX_MOVIMIENTOS
		db #ff
	rend


movimientos:
	dw MOV_UP, MOV_DO, MOV_LE, MOV_RI

movimientos_ord
	db -PANTALLA_TAM, PANTALLA_TAM, -1, 1



prioridades_movimientos:
;;	'x+y+': [LEFT, UP, RIGHT, DOWN],
	db %10000011
	db DIR_LE, DIR_UP, DIR_DO, DIR_RI
;;	'x+y-': [LEFT, DOWN, RIGHT, UP],
	db %10000010
	db DIR_LE, DIR_DO, DIR_UP, DIR_RI
;;	'x-y+': [RIGHT, UP, LEFT, DOWN],
	db %10000001
	db DIR_RI, DIR_UP, DIR_DO, DIR_LE
;;	'x-y-': [RIGHT, DOWN, LEFT, UP],
	db %10000000
	db DIR_RI, DIR_DO, DIR_UP, DIR_LE
;;	'y+x+': [UP, LEFT, DOWN, RIGHT],
	db %01000000
	db DIR_UP, DIR_LE, DIR_RI, DIR_DO
;;	'y+x-': [UP, RIGHT, DOWN, LEFT],
	db %01000001
	db DIR_UP, DIR_RI, DIR_LE, DIR_DO
;;	'y-x+': [DOWN, LEFT, UP, RIGHT],
	db %01000010
	db DIR_DO, DIR_LE, DIR_RI, DIR_UP
;;	'y-x-': [DOWN, RIGHT, UP, LEFT]
	db %01000000
	db DIR_DO, DIR_RI, DIR_LE, DIR_UP


