org #1000
run #1000

MAX_MOVIMIENTOS equ 3

PANTALLA_ANCHO equ 12
PANTALLA_ALTO  equ 10
PANTALLA_TAM   equ PANTALLA_ANCHO*PANTALLA_ALTO


DIR_UP equ 0
DIR_DO equ 1
DIR_LE equ 2
DIR_RI equ 3

MOV_UP equ #ff00
MOV_DO equ #0100
MOV_LE equ #ffff
MOV_RI equ #0001


call buscar_ruta



jr $




read "..\libs\macros_comparaciones.asm"
read "..\libs/listabytes.asm"
read "..\libs/formato44.asm"
read "..\libs/arrays.asm"





buscar_ruta:
	ld bc, (enemigo)
	ld e, PANTALLA_ANCHO
	call format44_get_secuencial ; a=numero de celda
	ld (lista_celdas_pisadas), a
	ld (enemigo_num_celda), a
	jr _br_ini
_br_loop_grande
	ld a, (num_celdas_pisadas)
	cp MAX_MOVIMIENTOS
	ret z
_br_ini
	ld de, (jugador) 
	ld bc, (enemigo)
	ld a, d
	cp b 
	jr nz, _br_sigue
	ld a, e
	cp c
	ret z

_br_sigue
	ld a, d
	sub b
	ld h, a  ;h=Jx-Ex
	
	ld a, e
	sub c
	ld l, a  ;l=Jy-Ey

	;creamos la clave en a
	xor a ; a=0
	bit 7, h
	jr nz, _br_creando_clave1
		or %00000010 ; =x+ ; x- = 0
_br_creando_clave1
	bit 7, l
	jr nz, _br_creando_clave2
		or %00000001 ; =y+ ; y- = 0
_br_creando_clave2
	ld iyh, a ; iyh=clave

	ld a, h
	sub l
	ld a, iyh  ;conserva el flag, a=clave
	jr c, _br_dy_mayor
	or %10000000
	jr _br_comprobar_direcciones
_br_dy_mayor
	or %01000000
_br_comprobar_direcciones
	;ld iyh, a ;; en iyh guardamos la clave
	ArraySearch prioridades_movimientos, 8, 5
	; 5=tam
	
	ld iyl, 4 ; direcciones
_br_loop
	inc hl ; hl->una direccion
	push hl
		ld a, (hl)
		call evaluar_movimiento_enemigo
	pop hl
	jp nz, almacenar_movimiento_enemigo
	dec iyl
	jr nz, _br_loop

	RET




;; in
;; a - direccion
;; out
;; z - z=1 la direccion no vale ; z=0=si vale
;; bc - nueva celda (y,x)
;; d - direccion
;; a - num celda
evaluar_movimiento_enemigo:
	ld (_mov_direccion), a
	cp 0
	ld ix, movimientos2
	jr z, _ev_no_add_ix
	ld de, 3
_ev_loop
	add ix, de
	dec a
	jr nz, _ev_loop
_ev_no_add_ix
	ld c, (ix+0)
	ld b, (ix+1)

	ld hl, (enemigo)
	add hl, bc ; hl=posible coordenada nueva del enemigo
	
	ld a, -1
	cp h
	ret z
	cp l
	ret z

	ld a, PANTALLA_ALTO
	cp h
	ret z
	ld a, PANTALLA_ANCHO
	cp l
	ret z
	
	ld b, h
	ld c, l

	ld a, (enemigo_num_celda)
	add a, (ix+2)

	ld hl, pantalla
	ld l, a
	xor a
	cp (hl)
	jr nz, _mov_novale
		; la celda vale
		or 1 ; z=0
		ld a, l 
		ld d, #00 ;direccion
		_mov_direccion equ $-1
		ret
_mov_novale
	xor a ; z=1
	ret
	



;; in
;; d - direccion
;; a - num celda
;; bc - celda (y,x)
;; mod: a bc de hl
almacenar_movimiento_enemigo:
	ld (enemigo), bc ; posicion nueva del enemigo
	ld (enemigo_num_celda), a
	ld e, a ; e=num celda

	ld hl, num_celdas_pisadas
	ld b, 0
	ld c, (hl)  ; bc=num.celdas_pisadas
	inc (hl) ; incrementamos el num.de celdas pisadas, pero trabajamos con el valor anterior

	; almacenar direccion
	ld hl, movimientos_enemigo
	add hl, bc
	ld (hl), d

	; almacenar la celda pisada
	ld hl, lista_celdas_pisadas+1
	add hl, bc
	ld (hl), e
	
	jp _br_loop_grande



org #1170
jugador:
jugador_x:
	db 9
jugador_y:
	db 1

enemigo:
enemigo_x:
	db 0
enemigo_y:
	db 6
enemigo_num_celda:
	db 0

lista_celdas_pisadas:
	repeat MAX_MOVIMIENTOS+1
		db #ff
	rend

num_celdas_pisadas:
	db 0

movimientos_enemigo:
	repeat MAX_MOVIMIENTOS
		db #ff
	rend


movimientos2:
	dw MOV_UP
		db -PANTALLA_ANCHO
	dw MOV_DO
		db PANTALLA_ANCHO
	dw MOV_LE
		db -1
	dw MOV_RI
		db 1

movimientos:
	dw MOV_UP, MOV_DO, MOV_LE, MOV_RI

direfencia_celdas:
	db -PANTALLA_ANCHO, PANTALLA_ANCHO, -1, 1


prioridades_movimientos:
	db %10000011, DIR_LE, DIR_UP, DIR_DO, DIR_RI
	db %10000010, DIR_LE, DIR_DO, DIR_UP, DIR_RI
	db %10000001, DIR_RI, DIR_UP, DIR_DO, DIR_LE
	db %10000000, DIR_RI, DIR_DO, DIR_UP, DIR_LE
	db %01000000, DIR_UP, DIR_LE, DIR_RI, DIR_DO
	db %01000001, DIR_UP, DIR_RI, DIR_LE, DIR_DO
	db %01000010, DIR_DO, DIR_LE, DIR_RI, DIR_UP
	db %01000000, DIR_DO, DIR_RI, DIR_LE, DIR_UP



align 256
pantalla:
	db 1,0,1,1,0,1,1,1,0,1,1,1
	db 1,0,0,0,0,1,1,1,0,1,1,0
	db 1,1,0,1,0,1,0,1,0,0,1,0
	db 0,0,0,0,0,0,0,1,0,0,0,0
	db 1,0,1,1,0,1,0,0,0,1,1,1
	db 1,1,1,0,0,1,1,1,0,1,0,1
	db 0,1,0,0,1,1,0,0,0,0,0,1
	db 0,0,0,0,0,0,0,0,1,0,0,0
	db 1,1,1,0,1,0,1,0,0,0,1,1
	db 0,0,1,0,0,0,0,0,0,0,1,1


