;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


TAM_SPR_SER_HORZ equ 9*16

OFFSET_SERP_ARRIBA    equ 0
OFFSET_SERP_ABAJO     equ TAM_SPRITE_PERSONAJE
OFFSET_SERP_IZQUIERDA equ OFFSET_SERP_ABAJO+TAM_SPRITE_PERSONAJE
OFFSET_SERP_DERECHA   equ OFFSET_SERP_IZQUIERDA+TAM_SPR_SER_HORZ
OFFSET_SERP_REPOSO    equ OFFSET_SERP_DERECHA+TAM_SPR_SER_HORZ

.array_offsets_sprites_serpiente:
	dw OFFSET_SERP_ARRIBA, OFFSET_SERP_ABAJO
	dw OFFSET_SERP_IZQUIERDA, OFFSET_SERP_DERECHA
	dw OFFSET_SERP_REPOSO

TAM_MAX_SPR_SERPIENTE equ 192


ID_SERP_REPOSO equ 4


SERP_OFFSET_PICAR equ 0
SERP_ALTO  equ 2
SERP_FN_RENDER equ 3
SERP_FN_CALC_CCAA equ 5
SERP_CELDA_REF equ 7
TAM_DATOS_DIR_SERP equ 8


.serpiente_datos_mov:  
	dw 0
	db 24
	dw sprite_render_con_transparencias
	dw ca_calcular_vertical_simple
	db 0
	dw SCREEN_WIDTH
	db 24
	dw sprite_render_con_transparencias
	dw ca_calcular_vertical_simple
	db 0
	dw -3+SCREEN_WIDTH
	db 16
	dw sprite9_render_con_transparencias
	dw ca_calcular_horizontal
	db -1
	dw SCREEN_WIDTH
	db 16
	dw sprite9_render_con_transparencias
	dw ca_calcular_horizontal
	db 0


MODO_PICAR    equ 1
MODO_NO_PICAR equ 0
FRAMES_PICADURA equ 12



.hay_serpiente:
	db 0

.modo_serpiente:
	db 0

.modo_picando:
	db 0
	

.direccion_picadura:
	db 0
	

.celda_afectada_picadura_cont:
	db 0

.sprite_serpiente_descomprimido:
	db #ff



serpiente_reset:
	xor a
	ld (hay_serpiente), a
	ld (modo_serpiente), a 
	ld (modo_picando), a
	ld (celda_afectada_picadura_cont), a
	ret
	


check_hay_serpiente:
	ld a, (hay_serpiente)
	cp 1
	ret



anadir_serpiente:
	ld a, (hay_objeto)
	cp 1
	ret z

	ld a, (hay_canibal)
	cp 1
	ret z

	ld a, (pantalla_ambiente)
	cp AMB_BOSQUE 
	ret nz 

_as_random
	ld a, (random_enemigo)
	cp PORCENTAJE_APARICION_SERPIENTE
	ret_si_A_mayor_o_igual

	ld a, 1
	ld (hay_serpiente), a
	ld_a MODO_PICAR
	ld (modo_serpiente), a

	ld a, (direccion_jugador)
	ld b, a
	call pantalla_get_random_celda_serpiente 

	ld a, l
	ld (enemigo_celda_num), a
	ld b, PANTALLA_ANCHO
	call format44_get_y_x 
	ld b, c 
	ld c, a 
	ld (enemigo_celda), bc
	
	ld a, #ff
	ld (sprite_serpiente_descomprimido), a

	ld b, ID_SERP_REPOSO
	call serpiente_get_sprite
	
	RET




render_serpiente:
	ld a, (modo_picando)
	cp 0
	jr nz, render_serpiente_picando
	


render_serpiente_reposo:
	ld b, ID_SERP_REPOSO
	call serpiente_get_sprite
	ld bc, (coordenadas_enemigo)
	call coordenada_calcular_desplazamiento 
	add_backbuffer_to h 
	ld de, spr_serpiente
	ld iyl, SPR_SPRITE_PERSONAJE_ALTO
	call sprite_render_con_transparencias
	
	ret



render_serpiente_picando:
	ld a, (direccion_picadura)
	ld b, a
	
	ld hl, modo_picando
	dec (hl)
	
	ArrayGetItem serpiente_datos_mov, TAM_DATOS_DIR_SERP 
	
	push hl 
	pop ix 
	
	ld bc, (coordenadas_enemigo)
	call coordenada_calcular_desplazamiento
	add_backbuffer_to h
	
	ldw_ri bc, ix, SERP_OFFSET_PICAR
	add hl, bc
	ld (__serp_destino), hl
	
	ld a, (ix+SERP_ALTO)
	ld iyl, a 
	
	ld de, spr_serpiente
	
	ldw_ri bc, ix, SERP_FN_RENDER
	ld (__serp_func_render), bc
	
	ld hl, #d350  
	__serp_destino equ $-2
	call #0000
	__serp_func_render equ $-2
	
	ret
	
	


macro CalcularCoordenadasSerpiente
	ld bc, (enemigo_celda)
	ld ix, coordenadas_enemigo
	call personaje_calcular_coordenadas
endm




serpiente_get_sprite:
	ld a, (sprite_serpiente_descomprimido)
	cp b
	ret z
	
	ld a, b
	ld (sprite_serpiente_descomprimido), a
	
	ld ixh, a 
		Descomprimir sprites_serpiente_zx0
	ld a, ixh
	
	ld hl, array_offsets_sprites_serpiente
	call get_word_array 
	ldw_indi bc
	ld hl, FIN
	add hl, bc
	
	ld de, spr_serpiente
	ld bc, TAM_MAX_SPR_SERPIENTE
	ldir 
	
	ld a, 1
	ld (sprites_descomprimidos), a
	
	RET




hay_colision_serpiente:
	ld a, (modo_serpiente)
	cp MODO_PICAR
	ret nz
	
	ld hl, animacion_jugador+ANIMACION_PASOS 
	xor a
	cp (hl)
	ret nz
	
	ld a, (jugador_celda_num)
	ld b, a 

	ld a, (enemigo_celda_num)
	
	ld c, 0 
	add a, -PANTALLA_ANCHO
	cp b
	jr z, _picar
	
	inc c
	add PANTALLA_ANCHO+PANTALLA_ANCHO
	cp b
	jr z, _picar
	
	inc c
	add -PANTALLA_ANCHO-1
	cp b
	jr z, _picar
	
	inc c
	add 2
	cp b
	jr z, _picar
	
	or 1 
	ret 
_picar
	
	ld a, (jugador_celda_x)
	ld hl, enemigo_celda_x
	sub (hl)
	
	call absA
	cp 2
	ret_si_A_mayor_o_igual	

	ld a, c 
	ld (__serp_dir_picadura), a
	ld (direccion_picadura), a
	
	ld a, FRAMES_PICADURA+2
	ld (celda_afectada_picadura_cont), a
	
	ld b, c
	call serpiente_get_sprite
	
	ld_a FRAMES_PICADURA
	ld (modo_picando), a
	
	ld_a MODO_NO_PICAR
	ld (modo_serpiente), a
	
	ld hl, serpiente_datos_mov
	ld b, #00
	__serp_dir_picadura equ $-1
	ArrayGetItem serpiente_datos_mov, TAM_DATOS_DIR_SERP 
	push hl
	pop ix
	
	ldw_ri bc, ix, SERP_FN_CALC_CCAA
	ld (__serp_call_fn_calc_ccaa), bc
	ld a, (enemigo_celda_num)
	add (ix+SERP_CELDA_REF)      
	ld iy, celdas_afectadas_enemigo

	call #0000
	__serp_call_fn_calc_ccaa equ $-2

	xor a 
	ret
	


	