;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


SALTO_ENTRE_BLOQUES_ZIGZAG  equ  #e000 + SCREEN_WIDTH

SALTO_ENTRE_BLOQUES_OPACOS  equ  #c848 - ANCHO_TILE_BYTES




macro maskByte
		ld a, (de)
		ld c, a     
		ld a, (bc)  
		and (hl)    
		or c        
		ld (hl), a  
endm 


macro maskByteAndNextHL incOdec
	repeat 5
		maskByte
		inc de
		if "incOdec"="inc"
			inc hl
		elseif "incOdec"="dec"
			dec hl
		endif
	rend
	
	maskByte

endm




pintar_bloque_6x8_mask:
	ld b, 1   
	
	maskByteAndNextHL inc
	set 3,h
	inc de
	maskByteAndNextHL dec
	set 4,h
	inc de
	maskByteAndNextHL inc
	res 3,h
	inc de
	maskByteAndNextHL dec
	set 5,h
	inc de
	maskByteAndNextHL inc
	set 3,h
	inc de
	maskByteAndNextHL dec
	res 4,h
	inc de
	maskByteAndNextHL inc
	res 3,h
	inc de
	maskByteAndNextHL dec
	
	ret
	
	


macro DrawOpaqueLine ancho, ultimo
	repeat ancho
		ldi 
	rend
	
	if ultimo=0
		ex de, hl             
			ld bc, #800-ancho 
			add hl, bc        
		ex de, hl             
	endif
endm



pintar_bloque_6x8_opaco:
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 0
	DrawOpaqueLine ANCHO_TILE_BYTES, 1
	RET





render_celda_parte_arriba_top:
	ld a, (ix + CELDA_ALTURA)
	cp 3
	ret nz
	
	ldw_ri de, ix, CELDA_SPRITE1
	call pintar_bloque_6x8_mask
	ret
	



render_celda_parte_arriba:
	
	ld a, (ix + CELDA_ALTURA)
	cp 3
	jr z, _rtpf_3
	cp 2
	jr z, _rtpa_2
	cp 1
	jr z, _rtpa_1
	ret

_rtpa_2
	ld bc, SCREEN_WIDTH
	add hl, bc
	jr _rtpf_2
_rtpa_1
	ld bc, SCREEN_WIDTH * 2
	add hl, bc
	jr _rtpf_1
	
_rtpf_3
	ldw_ri de, ix, CELDA_SPRITE1
	call pintar_bloque_6x8_mask
	ld bc, SALTO_ENTRE_BLOQUES_ZIGZAG
	add hl, bc
_rtpf_2
	ldw_ri de, ix, CELDA_SPRITE2
	call pintar_bloque_6x8_mask
	ld bc, SALTO_ENTRE_BLOQUES_ZIGZAG
	add hl, bc
_rtpf_1
	ldw_ri de, ix, CELDA_SPRITE3
	call pintar_bloque_6x8_mask

	RET




render_celda_completa:
	
	ld a, (ix + CELDA_ALTURA)
	cp 3
	jp z, _rccp_3
	cp 2
	jp z, _rcc_2
	cp 1
	jp z, _rcc_1
	jp _rcc_0

_rcc_2
	ld bc, SCREEN_WIDTH
	add hl, bc
	jp _rccp_2
_rcc_1
	ld bc, SCREEN_WIDTH * 2
	add hl, bc
	jp _rccp_1
_rcc_0
	ld bc, SCREEN_WIDTH * 3
	add hl, bc
	ex de, hl
	jp render_celda_parte_abajo_prv
	
_rccp_3
	ldw_ri de, ix, CELDA_SPRITE1
	call pintar_bloque_6x8_mask
	ld bc, SALTO_ENTRE_BLOQUES_ZIGZAG
	add hl, bc
_rccp_2
	ldw_ri de, ix, CELDA_SPRITE2
	call pintar_bloque_6x8_mask
	ld bc, SALTO_ENTRE_BLOQUES_ZIGZAG
	add hl, bc
_rccp_1
	ldw_ri de, ix, CELDA_SPRITE3
	call pintar_bloque_6x8_mask

	
	ld bc, SALTO_ENTRE_BLOQUES_ZIGZAG
	add hl, bc
	ex de, hl 
	

render_celda_parte_abajo_prv:
	ldw_ri hl, ix, CELDA_SPRITE4 
	call pintar_bloque_6x8_opaco 
	
	ex de, hl
		ld bc, SALTO_ENTRE_BLOQUES_OPACOS
		add hl, bc
	ex de, hl

	ldw_ri hl, ix, CELDA_SPRITE5
	call pintar_bloque_6x8_opaco

	RET




render_celda_parte_abajo:
	ld bc, SCREEN_WIDTH * 3
	add hl, bc
	ex de, hl 
	jp render_celda_parte_abajo_prv
	




render_celda_fila_abajo:
	ld a, (jugador_celda_num)
	cp PANTALLA_TAM-PANTALLA_ANCHO-1 
	ret_si_A_mayor_o_igual
	
	inc b
	add a, PANTALLA_ANCHO
	ld l, a
	pantalla_GetTile 
	call get_tile 
	
	call pantalla_get_offset_celda 
	add_backbuffer_to d
	call render_celda_parte_arriba
	RET


render_celda_parte_abajo_negro:
	ld bc, SCREEN_WIDTH * 3
	add hl, bc
	
	
	push iy
		SetParametrosPintarRectanguloAncho ANCHO_TILE_BYTES
	let _alto_bloques=ALTO_BASE_TILE_BYTES/8
		ld iyh, _alto_bloques
		call ph_borrar_rectangulo_alto
	pop iy
	
	RET

