;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------




_ancho_rectangulo equ 6
let _ULTIMA_COLUMNA = PANT_INI - _ancho_rectangulo
repeat PANTALLA_ANCHO
	let _ULTIMA_COLUMNA = _ULTIMA_COLUMNA + INCR_COLUMNA
rend

let _ULTIMA_FILA=PANT_INI
repeat 21
	let _ULTIMA_FILA=_ULTIMA_FILA+SCREEN_WIDTH
rend
	


ESQUINA_NO equ PANT_INI+SCREEN_WIDTH
ESQUINA_NE equ _ULTIMA_COLUMNA
ESQUINA_SO equ _ULTIMA_FILA  


DE_ARRIBA_ABAJO  equ 0
DE_ABAJO_ARRIBA  equ 1
DE_IZQUIERDA_DERECHA equ 2
DE_DERECHA_IZQUIERDA equ 3




macro ParametrosBorrarPantalla dir_memoria_inicio, frames, inc_dir_mem_siguiente_rect
	ld bc, dir_memoria_inicio
	ld (__bp_inicio), bc
	ldb_mv __bp_frames, frames
	ld bc, inc_dir_mem_siguiente_rect
	ld (__bp_incr_rect), bc
endm




macro ParametrosPresentarPantalla dir_mem_inicio, frames, incr_sig_rect
	ld bc, dir_mem_inicio
	ld (__pp_inicio1), bc
	
	ld a, frames
	ld (__pp_frames), a
	ld bc, incr_sig_rect
	ld (__pp_incremento_inicio_rectangulo), bc
endm



.direccion_efecto:
	db 0

.celdas_pintadas:
	db 0



render_pantalla_backbuffer:
	ld iyh, PANTALLA_TAM
	ld bc, pantalla
	ld hl, array_offsets_tiles



render_pantalla_backbuffer_parcial:
	
_rpp_tile
	call render_celda
	dec iyh
	jr nz, _rpp_tile
	ret





copiar_primera_linea:
	SetParametrosCopiarTrozoPantalla SCREEN_WIDTH, 1
	ld hl, PANT_INI
	add_backbuffer_to h
	call ph_copiar_rectangulo
	ret
	
borrar_primera_linea:
	SetParametrosPintarRectangulo SCREEN_WIDTH, 1
	ld hl, PANT_INI
	add_videopage_to h
	call ph_borrar_rectangulo


	ret



presentar_pantalla_arriba_abajo:
	call waitVSYNC
	call copiar_primera_linea
	
	ParametrosPresentarPantalla PANT_INI+SCREEN_WIDTH, 11, SCREEN_WIDTH+SCREEN_WIDTH
	SetParametrosCopiarTrozoPantalla SCREEN_WIDTH, 2
	
	jp presentar_pantalla
	
	

presentar_pantalla_abajo_arriba:
	ParametrosPresentarPantalla ESQUINA_SO, 11, -SCREEN_WIDTH-SCREEN_WIDTH
	SetParametrosCopiarTrozoPantalla SCREEN_WIDTH, 2
	
	jp presentar_pantalla
	
	

presentar_pantalla_derecha_izquierda:
	ParametrosPresentarPantalla ESQUINA_NE, 12, -_ancho_rectangulo
	SetParametrosCopiarTrozoPantalla  _ancho_rectangulo, 23
	
	jp presentar_pantalla
	
	

presentar_pantalla_izquierda_derecha:
	ParametrosPresentarPantalla PANT_INI, 12, _ancho_rectangulo
	SetParametrosCopiarTrozoPantalla  _ancho_rectangulo, 23
	
	jp presentar_pantalla
	
	

presentar_pantalla:
	call waitVSYNC

	ld hl, #0000 
	__pp_inicio1 equ $-2
	add_backbuffer_to h
	
	ld ixh, #00 
	__pp_frames equ $-1
	
_pp_loop
	push hl
		call ph_copiar_rectangulo
	pop hl

	ld bc, SCREEN_WIDTH
	__pp_incremento_inicio_rectangulo equ $-2
	add hl, bc
	
	call waitVSYNC
	dec ixh
	jr nz, _pp_loop
	
	ld a, (direccion_efecto)
	cp DE_ABAJO_ARRIBA
	ret nz
		call copiar_primera_linea
		ret




borrar_pantalla_arriba_abajo:
	ld a, DE_ARRIBA_ABAJO
	ld (direccion_efecto), a
	
	call waitVSYNC
	call borrar_primera_linea
	call borrar_parte_superior_backbuffer
	SetParametrosPintarRectangulo SCREEN_WIDTH, 2
	ParametrosBorrarPantalla ESQUINA_NO, 11, SCREEN_WIDTH+SCREEN_WIDTH
	jp borrar_pantalla_y_dibujar_backbuffer

	


borrar_pantalla_abajo_arriba:
	ld a, DE_ABAJO_ARRIBA
	ld (direccion_efecto), a
	
	call borrar_parte_superior_backbuffer
	SetParametrosPintarRectangulo SCREEN_WIDTH, 2
	ParametrosBorrarPantalla ESQUINA_SO, 11, -SCREEN_WIDTH-SCREEN_WIDTH
	jp borrar_pantalla_y_dibujar_backbuffer




borrar_pantalla_izquierda_derecha:
	
	call borrar_parte_superior_backbuffer
	SetParametrosPintarRectangulo _ancho_rectangulo, 23
	ParametrosBorrarPantalla PANT_INI, 12, _ancho_rectangulo
	jp borrar_pantalla_y_dibujar_backbuffer




borrar_pantalla_derecha_izquierda:
	
	call borrar_parte_superior_backbuffer
	SetParametrosPintarRectangulo _ancho_rectangulo, 23
	ParametrosBorrarPantalla ESQUINA_NE, 12, -_ancho_rectangulo
	jp borrar_pantalla_y_dibujar_backbuffer





borrar_parte_superior_backbuffer:
_tres_lineas equ SCREEN_WIDTH+SCREEN_WIDTH+SCREEN_WIDTH
	SetParametrosPintarRectangulo _tres_lineas, 1
	ld hl, PANT_INI
	add_backbuffer_to h
	call ph_borrar_rectangulo
	ret
	
borrar_pantalla_y_dibujar_backbuffer:
	call waitVSYNC
	
	ld a, PANTALLA_TAM
	ld (celdas_pintadas), a

	exx
		
		ld bc, pantalla
		ld hl, array_offsets_tiles
	exx

	ld hl, PANT_INI
__bp_inicio equ $-2
	add_videopage_to h
	
	ld ixh, #00 
__bp_frames equ $-1
_bp_loop
	push hl
		call ph_borrar_rectangulo
	pop hl

	ld bc, #0000 
__bp_incr_rect equ $-2
	add hl, bc

	push ix
		call render_v_celdas
	pop ix
__bp_wait
	call waitVSYNC
	
	dec ixh
	jr nz, _bp_loop
	
	ld a, (direccion_efecto)
	cp DE_ABAJO_ARRIBA
	jr nz, _bp_render_resto_celdas
		call borrar_primera_linea
		call render_v_celdas
		
_bp_render_resto_celdas
	exx
		ld a, (celdas_pintadas)
		ld iyh, a
		call render_pantalla_backbuffer_parcial
	exx

	ret








render_v_celdas:
	exx
		call render_celda
		call render_celda
		call render_celda
	exx
	ret 


render_celda:
	push bc
	push hl
		ldw_indi de 
		ldw_rr hl, de
		add_backbuffer_to h 
		ld a, (bc)  
		call get_tile 
		call render_celda_completa 
		
		ld hl, celdas_pintadas
		dec (hl)
	pop hl
	pop bc
	
	inc hl
	inc hl
	inc bc
	
	ret




macro CambiarPantalla efecto_borrado
	call borrar_pantalla_{efecto_borrado}
	
endm



