;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------




_ancho_rectangulo equ 3
let _ULTIMA_COLUMNA = PANT_INI - _ancho_rectangulo
repeat PANTALLA_ANCHO
	let _ULTIMA_COLUMNA = _ULTIMA_COLUMNA + INCR_COLUMNA
rend

let _ULTIMA_FILA=PANT_INI
repeat 22
	let _ULTIMA_FILA=_ULTIMA_FILA+SCREEN_WIDTH
rend
	


ESQUINA_NO equ PANT_INI
ESQUINA_NE equ _ULTIMA_COLUMNA
ESQUINA_SO equ _ULTIMA_FILA







render_pantalla_backbuffer:
	
	ld bc, pantalla
	ld hl, array_offsets_tiles
	ld iyh, PANTALLA_TAM
_rpp_tile
	push bc
	push hl
		ldw_indi de
		ldw_rr hl, de
		add_backbuffer_to h 
		ld a, (bc)
		call get_tile 
		call render_celda_completa 
	pop hl
	pop bc
	
	dec iyh
	ret z
		inc hl
		inc hl
		inc bc
		jr _rpp_tile




macro ParametrosPresentarPantalla dir_mem_inicio, frames, incr_sig_rect
	ld bc, dir_mem_inicio
	ld (__pp_inicio1), bc
	ld (__pp_inicio2), bc
	ld a, frames
	ld (__pp_frames), a
	ld bc, incr_sig_rect
	ld (__pp_incremento_inicio_rectangulo), bc
endm




macro ParametrosCopiarRectangulo ancho, alto
	ld a, alto
	ld (_cr_alto), a
	ld bc, ancho
	ld (__cr_ancho), bc
	ld bc, #800-ancho
	ld (__cr_800_ancho), bc
endm





macro CambiarPantalla efecto_borrado
	call borrar_pantalla_{efecto_borrado}
	
endm







presentar_pantalla_arriba_abajo:
	call waitVSYNC

	ParametrosPresentarPantalla PANT_INI, 23, SCREEN_WIDTH
	ParametrosCopiarRectangulo SCREEN_WIDTH, 8
	
	jp presentar_pantalla
	
	

presentar_pantalla_abajo_arriba:
	call waitVSYNC
	
	ParametrosPresentarPantalla ESQUINA_SO, 23, -SCREEN_WIDTH
	ParametrosCopiarRectangulo SCREEN_WIDTH, 8
	
	jp presentar_pantalla
	
	

presentar_pantalla_derecha_izquierda:
	call waitVSYNC

	ParametrosPresentarPantalla ESQUINA_NE, 24, -_ancho_rectangulo
	ParametrosCopiarRectangulo  _ancho_rectangulo, 23*8
	
	jp presentar_pantalla
	
	

presentar_pantalla_izquierda_derecha:
	call waitVSYNC
	
	ParametrosPresentarPantalla ESQUINA_NO, 24, _ancho_rectangulo
	ParametrosCopiarRectangulo  _ancho_rectangulo, 23*8
	
	jp presentar_pantalla
	
	

presentar_pantalla:
	ld hl, PANT_INI
__pp_inicio1 equ $-2
	add_backbuffer_to h

	ld de, PANT_INI
__pp_inicio2 equ $-2
	call get_video_page
	add a, d
	ld d, a
	
	ld ixh, 23
__pp_frames equ $-1
	
_pp_loop
	push de
	push hl
		call copiar_rectangulo
	pop hl
	pop de

	ld bc, SCREEN_WIDTH
__pp_incremento_inicio_rectangulo equ $-2
	add hl, bc
	ex de, hl
	add hl, bc
	ex de, hl
	
	call waitVSYNC
	dec ixh
	jr nz, _pp_loop
	ret





macro ParametrosBorrarPantalla dir_memoria_inicio, frames, inc_dir_mem_siguiente_rect
	ld bc, dir_memoria_inicio
	ld (__bp_inicio), bc
	ldb_mv __bp_frames, frames
	ld bc, inc_dir_mem_siguiente_rect
	ld (__bp_incr_rect), bc
endm





borrar_pantalla_arriba_abajo:
	call borrar_parte_superior_backbuffer
	sprite_SetParametrosRectangulo 0, SCREEN_WIDTH, 8
	ParametrosBorrarPantalla ESQUINA_NO, 23, SCREEN_WIDTH
	jp borrar_pantalla_y_dibujar_backbuffer

	


borrar_pantalla_abajo_arriba:
	call borrar_parte_superior_backbuffer
	sprite_SetParametrosRectangulo 0, SCREEN_WIDTH, 8
	ParametrosBorrarPantalla ESQUINA_SO, 23, -SCREEN_WIDTH
	jp borrar_pantalla_y_dibujar_backbuffer




borrar_pantalla_izquierda_derecha:
	call borrar_parte_superior_backbuffer
	sprite_SetParametrosRectangulo 0, 3, 8*23
	ParametrosBorrarPantalla ESQUINA_NO, 24, 3
	jp borrar_pantalla_y_dibujar_backbuffer




borrar_pantalla_derecha_izquierda:
	call borrar_parte_superior_backbuffer
	sprite_SetParametrosRectangulo 0, 3, 8*23
	ParametrosBorrarPantalla ESQUINA_NE, 24, -3
	jp borrar_pantalla_y_dibujar_backbuffer





borrar_parte_superior_backbuffer:
	sprite_SetParametrosRectangulo 0, SCREEN_WIDTH, 8*3
	ld hl, PANT_INI
	add_backbuffer_to h
	call sprite_render_rectangulo 
	ret



borrar_pantalla_y_dibujar_backbuffer:
	call waitVSYNC

	exx
		
		ld bc, pantalla
		ld hl, array_offsets_tiles
	exx
	
	ld hl, PANT_INI
__bp_inicio equ $-2
	add_videopage_to h
	
	ld ixh, 23
__bp_frames equ $-1
_bp_loop
	push hl
		
		call sprite_render_rectangulo 
	pop hl

	ld bc, SCREEN_WIDTH
__bp_incr_rect equ $-2
	add hl, bc

	ld a, ixh
	ld bc, #0114 
	call is_valor_en_rango
	jr nc, __bp_wait
		push ix
			call render_fragmento_pantalla_backbuffer
		pop ix
__bp_wait
	call waitVSYNC
	
	dec ixh
	jr nz, _bp_loop
	ret







render_fragmento_pantalla_backbuffer:
	exx
		
		ld iyh, 6 
_rfpb_2do_plano_otro
		push bc
		push hl
			ldw_indi de
			ldw_rr hl, de
			add_backbuffer_to h 
			ld a, (bc)
			call get_tile 
			call render_celda_completa 
		pop hl
		pop bc
		
		inc hl
		inc hl
		inc bc

		dec iyh
		jr nz, _rfpb_2do_plano_otro
	exx
	RET





copiar_rectangulo:
	ld iyl, #ff 
_cr_alto equ $-1
_cr_loop
	ld bc, #0000
__cr_ancho equ $-2
	ldir
	
	dec iyl
	ret z
	
	ld bc, #0000
__cr_800_ancho equ $-2
	repeat 2
		add hl, bc
		ex de, hl
	rend
	
	ld a, %00111000 
	and h
	jr nz, _cr_loop
		ld bc, #c000 + SCREEN_WIDTH
		repeat 2
			add hl, bc
			ex de, hl
		rend
		jr _cr_loop


