;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

render_personaje:
	ldw_indi bc
	call coordenada_calcular_desplazamiento 
	add_backbuffer_to h 

	ld a, (ix + ANIMACION_NFRAME)
	and %0000001
	jr z, _rp_no_cabeceo
		ld a, 8
		add h
		ld h, a
		
		ld a, %00111000 
		and h 
		jp nz, _rp_misma_pagina 
		ld a, #c0
		add h
		ld h, a
_rp_misma_pagina
_rp_no_cabeceo
	
	ldw_ri de, ix, ANIMACION_ARRAY_SPRITES
	ld a, (de)
	ld iyl, a 
	inc de

	push de
		ld bc, 6
		ex de, hl
			add hl, bc
		ex de, hl
		
		call sprite_render_con_transparencias 
	pop de

	call animacion_get_frame_cuerpo 
	ld a, (de) 
	ld iyl, a
	inc de 
	ex de, hl
		ld c, (hl)
		ld b, 0
		add hl, bc 
	ex de, hl 
	call sprite_render_con_transparencias

	RET
	


render_jugador:

	ld hl, coordenadas_jugador
	ld ix, animacion_jugador
	call render_personaje

	ret




render_canibal:

	ld hl, coordenadas_enemigo
	ld ix, animacion_enemigo
	call render_personaje

	ret






macro sprite_maskByte
		ld a, (de)
		ld c, a     
		ld a, (bc)  
		and (hl)    
		or c        
		ld (hl), a  
endm




sprite_render_con_transparencias:
	ld b, TABLA_MASCARAS 

	repeat SPR_SPRITE_PERSONAJE_ANCHO-1
		sprite_maskByte
		inc hl
		inc de
	rend
	sprite_maskByte

	inc de 
	ld bc, #801-SPR_SPRITE_PERSONAJE_ANCHO

	add hl, bc

	ld a, %00111000 
	and h 
	jp nz, _spr_next 
		ld bc, #c000 + SCREEN_WIDTH
		add hl, bc
		
_spr_next
	dec iyl
	jr nz, sprite_render_con_transparencias
	ret






sprite9_render_con_transparencias:
	ANCHO_SERPIENTE_PICADURA_HORIZONTAL equ 9
	ld b, TABLA_MASCARAS 
	ld iyh, ANCHO_SERPIENTE_PICADURA_HORIZONTAL 

_spr9_loop
		sprite_maskByte
		inc hl
		inc de
	dec iyh
	jr nz, _spr9_loop
	
	dec hl
	
	ld bc, #801-ANCHO_SERPIENTE_PICADURA_HORIZONTAL
	add hl, bc

	ld a, %00111000 
	and h 
	jp nz, _spr9_next 
		ld bc, #c000 + SCREEN_WIDTH
		add hl, bc
		
_spr9_next
	dec iyl
	jr nz, sprite9_render_con_transparencias
	ret

