;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


text_render_pre:
	ld hl, caracteres
	ld de, fin
	call dzx0

	sprite_SetAnchoSprite 2

	ret


pintar_texto:
_pt_caracter
	ld a, (hl)
	or a 
	ret z 
	
	cp ' '
	jr z, _pt_espacio
	cp '|'
	jr z, _pt_caracter_estrecho
	cp '{'
	jr z, _pt_back1
	cp '['
	jr z, _pt_back2

	push hl
	push de
		sub 48
		ld hl, FIN

		ld bc, TAM_CARACTER
		call get_array_item_bc 
		ld iyh, ALTO_CARACTER
		call sprite_render 
	pop de
	pop hl

	
	ld a, (hl)

	cp 'i'
	jr z, _pt_caracter_estrecho
	cp 'l'
	jr z, _pt_caracter_estrecho
	cp '`'
	jr z, _pt_caracter_estrecho
	cp ':'
	jr z, _pt_caracter_estrecho
	
_pt_espacio
	inc de
_pt_caracter_estrecho
	inc de	
	inc hl
	jr _pt_caracter
_pt_back2
	dec de
_pt_back1
	dec de
	inc hl
	jr _pt_caracter





cambiar_colores_fuente:
	call crear_matriz_conversion
	call sustituir_bytes
	ret



MATRIZ_DISPERSA equ slot0 



crear_matriz_conversion:
	ld de, MATRIZ_DISPERSA
	ld ixl, 8
_cmc_loop
	ld e, (hl) 
	ld a, (bc) 
	ld (de), a 
	inc hl
	inc bc
	dec ixl
	jr nz, _cmc_loop
	ret
	
	

sustituir_bytes:
	ld bc, 1350 
	ld hl, FIN
	ld de, matriz_dispersa
_sb_loop
	
	ld e, (hl)  
	ld a, (de)  
	ld (hl), a  

	inc hl
	dec bc

	xor a  
	or b   
	or c   
	jr nz, _sb_loop

	
	ret