;;-----------------------------LICENSE NOTICE------------------------------------
;; (C) Gallegux+z80@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;- poner winape en pausa
;;- cargar "ventanas_texto/ventanas.asm"
;;- hay dependencias:
;;	* paletas.asm se debe colocar en la misma posicion que en main.asm
;;	* la direccion de origen (DIR_INICIO) debe ser la misma que sprites_celdas_primarias en main.asm
;;- compilar
;;- grabar el contenido de la memoria desde DIR_INICIO a DIR_FINAL a temp\ventanas.bin
;;- grabar el contenido que hay entre las lineas ///// a "ventanas_texto\desplazamientos_ventanas.h"
;;- ejecutar pre_ventanas.bat, se genera "incluir\ventanas.bin.zx0"  (se ahorran unos 500 bytes)



nolist
read "..\libs/macros_struts.asm"
read "..\cls_ventana.h"
read "..\libs\colores.asm"

org #ff50
read  "../paletas.asm"

DIR_INICIO  equ  #1DC0 


SCREEN_WIDTH equ #48

LIN01 equ SCREEN_WIDTH*8
LIN02 equ LIN01+SCREEN_WIDTH
LIN03 equ LIN02+SCREEN_WIDTH
LIN04 equ LIN03+SCREEN_WIDTH
LIN05 equ LIN04+SCREEN_WIDTH
LIN06 equ LIN05+SCREEN_WIDTH
LIN07 equ LIN06+SCREEN_WIDTH
LIN08 equ LIN07+SCREEN_WIDTH
LIN09 equ LIN08+SCREEN_WIDTH
LIN10 equ LIN09+SCREEN_WIDTH
LIN11 equ LIN10+SCREEN_WIDTH
LIN12 equ LIN11+SCREEN_WIDTH
LIN13 equ LIN12+SCREEN_WIDTH
LIN14 equ LIN13+SCREEN_WIDTH
LIN15 equ LIN14+SCREEN_WIDTH
LIN16 equ LIN15+SCREEN_WIDTH
LIN17 equ LIN16+SCREEN_WIDTH
LIN18 equ LIN17+SCREEN_WIDTH


org DIR_INICIO 

.txt_game_over:
	db "GAME OVER", 0
	
.txt_cant_continue:
	db "can`t continue", 0
	
.txt_native:
	db "A native will find you and", 0

.txt_probably:
	db "probably you serve as food", 0
	
	

.ventana_cueva_sin_antorcha:
	new_VENTANA       LIN01+ 9, 54, 9
	newCambioColores  colores_letras_normales, colores_letras_personaje
	newLineaTexto     LIN02+16, "I can`t see anything@"
	newLineaTexto     LIN04+19, "And I can`t go on@"
	newLineaTexto     LIN06+11, "I need help from something"
	newLineaTexto     LIN08+26, "or someone"
	newFinVentana



.ventana_cueva_sin_pelota:
	new_VENTANA       LIN02+ 16, 40, 7
	newCambioColores  colores_letras_normales, colores_letras_personaje
	newLineaTexto     LIN03+18, "I have got a torch"
	newLineaTexto     LIN05+21, "but I don`t know"
	newLineaTexto     LIN07+21, "how to make fire"
	newFinVentana



.ventana_pausa:
	new_VENTANA       LIN04+13, 47, 8
	newCambioColores  colores_letras_normales, colores_letras_titulo_ventana
	newLineaTexto     LIN05+26, "GAME PAUSED"
	newCambioColores  colores_letras_titulo_ventana, colores_letras_pausa
	newLineaTexto     LIN08+20, "Press ESC to exit"
	newLineaTexto     LIN10+15, "or any key to continue"
	newFinVentana



.ventana_pelota:
	new_VENTANA       LIN03+12, 48, 9
	newCambioColores  colores_letras_normales, colores_letras_personaje
	newLineaTexto     LIN04+15, "Oh@ My big friend Willy@"
	newLineaTexto     LIN06+16, "You always inspire me@"
	newLineaTexto     LIN08+28, "I feel<<<"
	newLineaTexto     LIN10+14, "like I could make a fire"
	newFinVentana





.ventana_nativa_1:
	new_VENTANA       LIN01+13, 35, 7
	newCambioColores  colores_letras_normales, colores_letras_nativa
	newLineaTexto     LIN02+17, "Don`t you know"
	newLineaTexto     LIN04+18, "how to knock"
	newLineaTexto     LIN06+15, "before entering?"
	newFinVentana



.ventana_nativa_2:
	new_VENTANA       LIN03+16, 32, 3
	newCambioColores  colores_letras_normales, colores_letras_nativa
	newLineaTexto     LIN04+18, "Leave me alone@"
	newFinVentana



.ventana_objetivo_conseguido:
	new_VENTANA       LIN01+ 8, 56, 12
	newCambioColores  colores_letras_normales, colores_letras_titulo_ventana
	newLineaTexto     LIN02+17, "CONGRATULATIONS @@@"
	newCambioColores  colores_letras_titulo_ventana, colores_letras_ganar
	newLineaTexto     LIN05+10, "You got the needed objects"
	newLineaTexto     LIN07+13, "to build a raft to leave"
	newLineaTexto     LIN09+12, "the island and be on time"
	newLineaTexto     LIN11+20, "for your wedding"
	newFinVentana



.ventana_game_over_serpiente:
	new_VENTANA       LIN01+ 13, 45, 12
	newCambioColores  colores_letras_normales, colores_letras_titulo_ventana
	newLineaTextoRef  LIN02+27, txt_game_over
	newCambioColores  colores_letras_titulo_ventana, colores_letras_game_over
	newLineaTexto     LIN05+15, "You have not resisted"
	newLineaTexto     LIN07+21, "the snake venom"
	newLineaTexto     LIN09+21, "What will become"
	newLineaTexto     LIN11+25, "of you now?"
	newFinVentana



.ventana_game_over_atrapado:
	new_VENTANA       LIN01+ 8, 56, 12
	newCambioColores  colores_letras_normales, colores_letras_titulo_ventana
	newLineaTextoRef  LIN02+27, txt_game_over
	newCambioColores  colores_letras_titulo_ventana, colores_letras_game_over
	newLineaTexto     LIN05+10, "You have been captured and"
	newLineaTextoRef  LIN07+10, txt_probably
	newLineaTexto     LIN09+14, "You will never see your"
	newLineaTexto     LIN11+22, "girlfriend again"
	newFinVentana



.ventana_game_over_sin_agua:
	new_VENTANA       LIN01+ 8, 55, 12
	newCambioColores  colores_letras_normales, colores_letras_titulo_ventana
	newLineaTextoRef  LIN02+27, txt_game_over
	newCambioColores  colores_letras_titulo_ventana, colores_letras_game_over
	newLineaTexto     LIN05+13, "You are deshidrated and"
	newLineaTextoRef  LIN07+23, txt_cant_continue
	newLineaTextoRef  LIN09+12, txt_native
	newLineaTextoRef  LIN11+10, txt_probably
	newFinVentana



.ventana_game_over_sin_energia:
	new_VENTANA       LIN01+ 8, 55, 12
	newCambioColores  colores_letras_normales, colores_letras_titulo_ventana
	newLineaTextoRef  LIN02+27, txt_game_over
	newCambioColores  colores_letras_titulo_ventana, colores_letras_game_over
	newLineaTexto     LIN05+14, "You have no energy and"
	newLineaTextoRef  LIN07+23, txt_cant_continue
	newLineaTextoRef  LIN09+12, txt_native
	newLineaTextoRef  LIN11+10, txt_probably
	newFinVentana



let _dirva=txt_game_over
macro printdv _ventana
	let tamv=_ventana-_dirva
	print "{_ventana}  equ  #$_ventana  ; tam &tamv"
	let _dirva=_ventana
endm

print ";DIR_INICIO  $DIR_INICIO"
print ";/////////////////////////////////////////////////////////"
printdv ventana_cueva_sin_antorcha
printdv ventana_cueva_sin_pelota
printdv ventana_pausa
printdv ventana_pelota
printdv ventana_nativa_1
printdv ventana_nativa_2
printdv ventana_objetivo_conseguido
printdv ventana_game_over_serpiente
printdv ventana_game_over_atrapado
printdv ventana_game_over_sin_agua
printdv ventana_game_over_sin_energia
print ";/////////////////////////////////////////////////////////"
let fin=$-1
print ";DIR_FINAL  $fin"
